/* BatteryDockItem.c generated by valac 0.56.14, the Vala compiler
 * generated from BatteryDockItem.vala, do not modify */

/**/
/*  Copyright (C) 2018 Faissal Bensefia*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "docklet-battery.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "plank.h"
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define DOCKY_BATTERY_DOCK_ITEM_BAT_BASE_PATH "/sys/class/power_supply"
#define DOCKY_BATTERY_DOCK_ITEM_BAT_CAPACITY DOCKY_BATTERY_DOCK_ITEM_BAT_BASE_PATH "/%s/capacity"
#define DOCKY_BATTERY_DOCK_ITEM_BAT_CAPACITY_LEVEL DOCKY_BATTERY_DOCK_ITEM_BAT_BASE_PATH "/%s/capacity_level"
#define DOCKY_BATTERY_DOCK_ITEM_BAT_STATUS DOCKY_BATTERY_DOCK_ITEM_BAT_BASE_PATH "/%s/status"
#define DOCKY_BATTERY_DOCK_ITEM_BAT_CHARGE_NOW DOCKY_BATTERY_DOCK_ITEM_BAT_BASE_PATH "/%s/charge_now"
#define DOCKY_BATTERY_DOCK_ITEM_BAT_ALARM DOCKY_BATTERY_DOCK_ITEM_BAT_BASE_PATH "/%s/alarm"

enum  {
	DOCKY_BATTERY_DOCK_ITEM_0_PROPERTY,
	DOCKY_BATTERY_DOCK_ITEM_NUM_PROPERTIES
};
static GParamSpec* docky_battery_dock_item_properties[DOCKY_BATTERY_DOCK_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DockyBatteryDockItemPrivate {
	gchar* current_battery;
	guint timer_id;
};

static gint DockyBatteryDockItem_private_offset;
static gpointer docky_battery_dock_item_parent_class = NULL;

static gint docky_battery_dock_item_get_capacity (DockyBatteryDockItem* self,
                                           GError** error);
static gchar* docky_battery_dock_item_get_capacity_level (DockyBatteryDockItem* self,
                                                   GError** error);
static gchar* docky_battery_dock_item_get_status (DockyBatteryDockItem* self,
                                           GError** error);
static gboolean docky_battery_dock_item_update (DockyBatteryDockItem* self);
static GObject * docky_battery_dock_item_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void docky_battery_dock_item_finalize (GObject * obj);
static GType docky_battery_dock_item_get_type_once (void);

static inline gpointer
docky_battery_dock_item_get_instance_private (DockyBatteryDockItem* self)
{
	return G_STRUCT_MEMBER_P (self, DockyBatteryDockItem_private_offset);
}

/**
 * {@inheritDoc}
 */
DockyBatteryDockItem*
docky_battery_dock_item_construct_with_dockitem_file (GType object_type,
                                                      GFile* file)
{
	DockyBatteryDockItem * self = NULL;
	PlankDockItemPreferences* _tmp0_;
	PlankDockItemPreferences* _tmp1_;
#line 39 "../docklets/Battery/BatteryDockItem.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 41 "../docklets/Battery/BatteryDockItem.vala"
	_tmp0_ = plank_dock_item_preferences_new_with_file (file);
#line 41 "../docklets/Battery/BatteryDockItem.vala"
	_tmp1_ = _tmp0_;
#line 41 "../docklets/Battery/BatteryDockItem.vala"
	self = (DockyBatteryDockItem*) g_object_new (object_type, "Prefs", _tmp1_, NULL);
#line 41 "../docklets/Battery/BatteryDockItem.vala"
	_g_object_unref0 (_tmp1_);
#line 39 "../docklets/Battery/BatteryDockItem.vala"
	return self;
#line 105 "BatteryDockItem.c"
}

DockyBatteryDockItem*
docky_battery_dock_item_new_with_dockitem_file (GFile* file)
{
#line 39 "../docklets/Battery/BatteryDockItem.vala"
	return docky_battery_dock_item_construct_with_dockitem_file (DOCKY_TYPE_BATTERY_DOCK_ITEM, file);
#line 113 "BatteryDockItem.c"
}

static gint
docky_battery_dock_item_get_capacity (DockyBatteryDockItem* self,
                                      GError** error)
{
	gchar* s = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	GError* _inner_error0_ = NULL;
	gint result;
#line 60 "../docklets/Battery/BatteryDockItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 63 "../docklets/Battery/BatteryDockItem.vala"
	_tmp0_ = self->priv->current_battery;
#line 63 "../docklets/Battery/BatteryDockItem.vala"
	_tmp1_ = g_strdup_printf (DOCKY_BATTERY_DOCK_ITEM_BAT_CAPACITY, _tmp0_);
#line 63 "../docklets/Battery/BatteryDockItem.vala"
	_tmp2_ = _tmp1_;
#line 63 "../docklets/Battery/BatteryDockItem.vala"
	g_file_get_contents (_tmp2_, &_tmp3_, NULL, &_inner_error0_);
#line 63 "../docklets/Battery/BatteryDockItem.vala"
	_g_free0 (s);
#line 63 "../docklets/Battery/BatteryDockItem.vala"
	s = _tmp3_;
#line 63 "../docklets/Battery/BatteryDockItem.vala"
	_g_free0 (_tmp2_);
#line 63 "../docklets/Battery/BatteryDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../docklets/Battery/BatteryDockItem.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 147 "BatteryDockItem.c"
			gint _tmp4_ = -1;
#line 63 "../docklets/Battery/BatteryDockItem.vala"
			g_propagate_error (error, _inner_error0_);
#line 63 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (s);
#line 63 "../docklets/Battery/BatteryDockItem.vala"
			return _tmp4_;
#line 155 "BatteryDockItem.c"
		} else {
			gint _tmp5_ = -1;
#line 63 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (s);
#line 63 "../docklets/Battery/BatteryDockItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../docklets/Battery/BatteryDockItem.vala"
			g_clear_error (&_inner_error0_);
#line 63 "../docklets/Battery/BatteryDockItem.vala"
			return _tmp5_;
#line 166 "BatteryDockItem.c"
		}
	}
#line 64 "../docklets/Battery/BatteryDockItem.vala"
	result = atoi (s);
#line 64 "../docklets/Battery/BatteryDockItem.vala"
	_g_free0 (s);
#line 64 "../docklets/Battery/BatteryDockItem.vala"
	return result;
#line 175 "BatteryDockItem.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 196 "BatteryDockItem.c"
}

static gchar*
docky_battery_dock_item_get_capacity_level (DockyBatteryDockItem* self,
                                            GError** error)
{
	gchar* s = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 67 "../docklets/Battery/BatteryDockItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../docklets/Battery/BatteryDockItem.vala"
	_tmp0_ = self->priv->current_battery;
#line 70 "../docklets/Battery/BatteryDockItem.vala"
	_tmp1_ = g_strdup_printf (DOCKY_BATTERY_DOCK_ITEM_BAT_CAPACITY_LEVEL, _tmp0_);
#line 70 "../docklets/Battery/BatteryDockItem.vala"
	_tmp2_ = _tmp1_;
#line 70 "../docklets/Battery/BatteryDockItem.vala"
	g_file_get_contents (_tmp2_, &_tmp3_, NULL, &_inner_error0_);
#line 70 "../docklets/Battery/BatteryDockItem.vala"
	_g_free0 (s);
#line 70 "../docklets/Battery/BatteryDockItem.vala"
	s = _tmp3_;
#line 70 "../docklets/Battery/BatteryDockItem.vala"
	_g_free0 (_tmp2_);
#line 70 "../docklets/Battery/BatteryDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../docklets/Battery/BatteryDockItem.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 70 "../docklets/Battery/BatteryDockItem.vala"
			g_propagate_error (error, _inner_error0_);
#line 70 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (s);
#line 70 "../docklets/Battery/BatteryDockItem.vala"
			return NULL;
#line 237 "BatteryDockItem.c"
		} else {
#line 70 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (s);
#line 70 "../docklets/Battery/BatteryDockItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../docklets/Battery/BatteryDockItem.vala"
			g_clear_error (&_inner_error0_);
#line 70 "../docklets/Battery/BatteryDockItem.vala"
			return NULL;
#line 247 "BatteryDockItem.c"
		}
	}
#line 71 "../docklets/Battery/BatteryDockItem.vala"
	_tmp4_ = string_strip (s);
#line 71 "../docklets/Battery/BatteryDockItem.vala"
	result = _tmp4_;
#line 71 "../docklets/Battery/BatteryDockItem.vala"
	_g_free0 (s);
#line 71 "../docklets/Battery/BatteryDockItem.vala"
	return result;
#line 258 "BatteryDockItem.c"
}

static gchar*
docky_battery_dock_item_get_status (DockyBatteryDockItem* self,
                                    GError** error)
{
	gchar* s = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 74 "../docklets/Battery/BatteryDockItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../docklets/Battery/BatteryDockItem.vala"
	_tmp0_ = self->priv->current_battery;
#line 77 "../docklets/Battery/BatteryDockItem.vala"
	_tmp1_ = g_strdup_printf (DOCKY_BATTERY_DOCK_ITEM_BAT_STATUS, _tmp0_);
#line 77 "../docklets/Battery/BatteryDockItem.vala"
	_tmp2_ = _tmp1_;
#line 77 "../docklets/Battery/BatteryDockItem.vala"
	g_file_get_contents (_tmp2_, &_tmp3_, NULL, &_inner_error0_);
#line 77 "../docklets/Battery/BatteryDockItem.vala"
	_g_free0 (s);
#line 77 "../docklets/Battery/BatteryDockItem.vala"
	s = _tmp3_;
#line 77 "../docklets/Battery/BatteryDockItem.vala"
	_g_free0 (_tmp2_);
#line 77 "../docklets/Battery/BatteryDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../docklets/Battery/BatteryDockItem.vala"
		if (_inner_error0_->domain == G_FILE_ERROR) {
#line 77 "../docklets/Battery/BatteryDockItem.vala"
			g_propagate_error (error, _inner_error0_);
#line 77 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (s);
#line 77 "../docklets/Battery/BatteryDockItem.vala"
			return NULL;
#line 299 "BatteryDockItem.c"
		} else {
#line 77 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (s);
#line 77 "../docklets/Battery/BatteryDockItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../docklets/Battery/BatteryDockItem.vala"
			g_clear_error (&_inner_error0_);
#line 77 "../docklets/Battery/BatteryDockItem.vala"
			return NULL;
#line 309 "BatteryDockItem.c"
		}
	}
#line 78 "../docklets/Battery/BatteryDockItem.vala"
	_tmp4_ = string_strip (s);
#line 78 "../docklets/Battery/BatteryDockItem.vala"
	result = _tmp4_;
#line 78 "../docklets/Battery/BatteryDockItem.vala"
	_g_free0 (s);
#line 78 "../docklets/Battery/BatteryDockItem.vala"
	return result;
#line 320 "BatteryDockItem.c"
}

static gboolean
docky_battery_dock_item_update (DockyBatteryDockItem* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 81 "../docklets/Battery/BatteryDockItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 330 "BatteryDockItem.c"
	{
		gchar* new_icon = NULL;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* status = NULL;
		gchar* _tmp2_;
		gint capacity = 0;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gchar* capacity_level = NULL;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		GQuark _tmp9_ = 0U;
#line 88 "../docklets/Battery/BatteryDockItem.vala"
		static GQuark _tmp8_label0 = 0;
#line 88 "../docklets/Battery/BatteryDockItem.vala"
		static GQuark _tmp8_label1 = 0;
#line 88 "../docklets/Battery/BatteryDockItem.vala"
		static GQuark _tmp8_label2 = 0;
#line 88 "../docklets/Battery/BatteryDockItem.vala"
		static GQuark _tmp8_label3 = 0;
#line 88 "../docklets/Battery/BatteryDockItem.vala"
		static GQuark _tmp8_label4 = 0;
#line 88 "../docklets/Battery/BatteryDockItem.vala"
		static GQuark _tmp8_label5 = 0;
#line 357 "BatteryDockItem.c"
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		GQuark _tmp19_ = 0U;
#line 110 "../docklets/Battery/BatteryDockItem.vala"
		static GQuark _tmp18_label0 = 0;
#line 110 "../docklets/Battery/BatteryDockItem.vala"
		static GQuark _tmp18_label1 = 0;
#line 365 "BatteryDockItem.c"
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 85 "../docklets/Battery/BatteryDockItem.vala"
		_tmp1_ = docky_battery_dock_item_get_status (self, &_inner_error0_);
#line 85 "../docklets/Battery/BatteryDockItem.vala"
		_tmp0_ = _tmp1_;
#line 85 "../docklets/Battery/BatteryDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (new_icon);
#line 377 "BatteryDockItem.c"
			goto __catch0_g_error;
		}
#line 85 "../docklets/Battery/BatteryDockItem.vala"
		_tmp2_ = g_utf8_strdown (_tmp0_, (gssize) -1);
#line 85 "../docklets/Battery/BatteryDockItem.vala"
		status = _tmp2_;
#line 86 "../docklets/Battery/BatteryDockItem.vala"
		capacity = docky_battery_dock_item_get_capacity (self, &_inner_error0_);
#line 86 "../docklets/Battery/BatteryDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 86 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (status);
#line 86 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (_tmp0_);
#line 86 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (new_icon);
#line 394 "BatteryDockItem.c"
			goto __catch0_g_error;
		}
#line 87 "../docklets/Battery/BatteryDockItem.vala"
		_tmp4_ = docky_battery_dock_item_get_capacity_level (self, &_inner_error0_);
#line 87 "../docklets/Battery/BatteryDockItem.vala"
		_tmp3_ = _tmp4_;
#line 87 "../docklets/Battery/BatteryDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (status);
#line 87 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (_tmp0_);
#line 87 "../docklets/Battery/BatteryDockItem.vala"
			_g_free0 (new_icon);
#line 409 "BatteryDockItem.c"
			goto __catch0_g_error;
		}
#line 87 "../docklets/Battery/BatteryDockItem.vala"
		_tmp5_ = g_utf8_strdown (_tmp3_, (gssize) -1);
#line 87 "../docklets/Battery/BatteryDockItem.vala"
		capacity_level = _tmp5_;
#line 88 "../docklets/Battery/BatteryDockItem.vala"
		_tmp6_ = capacity_level;
#line 88 "../docklets/Battery/BatteryDockItem.vala"
		_tmp7_ = _tmp6_;
#line 88 "../docklets/Battery/BatteryDockItem.vala"
		_tmp9_ = (NULL == _tmp7_) ? 0 : g_quark_from_string (_tmp7_);
#line 88 "../docklets/Battery/BatteryDockItem.vala"
		if (_tmp9_ == ((0 != _tmp8_label0) ? _tmp8_label0 : (_tmp8_label0 = g_quark_from_static_string ("full")))) {
#line 88 "../docklets/Battery/BatteryDockItem.vala"
			switch (0) {
#line 426 "BatteryDockItem.c"
				default:
				{
					gchar* _tmp10_;
#line 90 "../docklets/Battery/BatteryDockItem.vala"
					_tmp10_ = g_strdup ("battery-full");
#line 90 "../docklets/Battery/BatteryDockItem.vala"
					_g_free0 (new_icon);
#line 90 "../docklets/Battery/BatteryDockItem.vala"
					new_icon = _tmp10_;
#line 91 "../docklets/Battery/BatteryDockItem.vala"
					break;
#line 438 "BatteryDockItem.c"
				}
			}
		} else if ((_tmp9_ == ((0 != _tmp8_label1) ? _tmp8_label1 : (_tmp8_label1 = g_quark_from_static_string ("high")))) || (_tmp9_ == ((0 != _tmp8_label2) ? _tmp8_label2 : (_tmp8_label2 = g_quark_from_static_string ("normal"))))) {
#line 88 "../docklets/Battery/BatteryDockItem.vala"
			switch (0) {
#line 444 "BatteryDockItem.c"
				default:
				{
					gchar* _tmp11_;
#line 94 "../docklets/Battery/BatteryDockItem.vala"
					_tmp11_ = g_strdup ("battery-good");
#line 94 "../docklets/Battery/BatteryDockItem.vala"
					_g_free0 (new_icon);
#line 94 "../docklets/Battery/BatteryDockItem.vala"
					new_icon = _tmp11_;
#line 95 "../docklets/Battery/BatteryDockItem.vala"
					break;
#line 456 "BatteryDockItem.c"
				}
			}
		} else if (_tmp9_ == ((0 != _tmp8_label3) ? _tmp8_label3 : (_tmp8_label3 = g_quark_from_static_string ("low")))) {
#line 88 "../docklets/Battery/BatteryDockItem.vala"
			switch (0) {
#line 462 "BatteryDockItem.c"
				default:
				{
					gchar* _tmp12_;
#line 97 "../docklets/Battery/BatteryDockItem.vala"
					_tmp12_ = g_strdup ("battery-low");
#line 97 "../docklets/Battery/BatteryDockItem.vala"
					_g_free0 (new_icon);
#line 97 "../docklets/Battery/BatteryDockItem.vala"
					new_icon = _tmp12_;
#line 98 "../docklets/Battery/BatteryDockItem.vala"
					break;
#line 474 "BatteryDockItem.c"
				}
			}
		} else if (_tmp9_ == ((0 != _tmp8_label4) ? _tmp8_label4 : (_tmp8_label4 = g_quark_from_static_string ("critical")))) {
#line 88 "../docklets/Battery/BatteryDockItem.vala"
			switch (0) {
#line 480 "BatteryDockItem.c"
				default:
				{
					gchar* _tmp13_;
#line 100 "../docklets/Battery/BatteryDockItem.vala"
					_tmp13_ = g_strdup ("battery-caution");
#line 100 "../docklets/Battery/BatteryDockItem.vala"
					_g_free0 (new_icon);
#line 100 "../docklets/Battery/BatteryDockItem.vala"
					new_icon = _tmp13_;
#line 101 "../docklets/Battery/BatteryDockItem.vala"
					break;
#line 492 "BatteryDockItem.c"
				}
			}
		} else if (_tmp9_ == ((0 != _tmp8_label5) ? _tmp8_label5 : (_tmp8_label5 = g_quark_from_static_string ("unknown")))) {
#line 88 "../docklets/Battery/BatteryDockItem.vala"
			switch (0) {
#line 498 "BatteryDockItem.c"
				default:
				{
					gchar* _tmp14_;
#line 103 "../docklets/Battery/BatteryDockItem.vala"
					_tmp14_ = g_strdup ("battery-empty");
#line 103 "../docklets/Battery/BatteryDockItem.vala"
					_g_free0 (new_icon);
#line 103 "../docklets/Battery/BatteryDockItem.vala"
					new_icon = _tmp14_;
#line 104 "../docklets/Battery/BatteryDockItem.vala"
					break;
#line 510 "BatteryDockItem.c"
				}
			}
		} else {
#line 88 "../docklets/Battery/BatteryDockItem.vala"
			switch (0) {
#line 516 "BatteryDockItem.c"
				default:
				{
					gchar* _tmp15_;
#line 106 "../docklets/Battery/BatteryDockItem.vala"
					_tmp15_ = g_strdup ("battery-missing");
#line 106 "../docklets/Battery/BatteryDockItem.vala"
					_g_free0 (new_icon);
#line 106 "../docklets/Battery/BatteryDockItem.vala"
					new_icon = _tmp15_;
#line 107 "../docklets/Battery/BatteryDockItem.vala"
					break;
#line 528 "BatteryDockItem.c"
				}
			}
		}
#line 110 "../docklets/Battery/BatteryDockItem.vala"
		_tmp16_ = status;
#line 110 "../docklets/Battery/BatteryDockItem.vala"
		_tmp17_ = _tmp16_;
#line 110 "../docklets/Battery/BatteryDockItem.vala"
		_tmp19_ = (NULL == _tmp17_) ? 0 : g_quark_from_string (_tmp17_);
#line 110 "../docklets/Battery/BatteryDockItem.vala"
		if ((_tmp19_ == ((0 != _tmp18_label0) ? _tmp18_label0 : (_tmp18_label0 = g_quark_from_static_string ("charging")))) || (_tmp19_ == ((0 != _tmp18_label1) ? _tmp18_label1 : (_tmp18_label1 = g_quark_from_static_string ("full"))))) {
#line 110 "../docklets/Battery/BatteryDockItem.vala"
			switch (0) {
#line 542 "BatteryDockItem.c"
				default:
				{
					const gchar* _tmp20_;
					gchar* _tmp21_;
#line 113 "../docklets/Battery/BatteryDockItem.vala"
					_tmp20_ = new_icon;
#line 113 "../docklets/Battery/BatteryDockItem.vala"
					_tmp21_ = g_strconcat (_tmp20_, "-charging", NULL);
#line 113 "../docklets/Battery/BatteryDockItem.vala"
					_g_free0 (new_icon);
#line 113 "../docklets/Battery/BatteryDockItem.vala"
					new_icon = _tmp21_;
#line 114 "../docklets/Battery/BatteryDockItem.vala"
					break;
#line 557 "BatteryDockItem.c"
				}
			}
		} else {
#line 110 "../docklets/Battery/BatteryDockItem.vala"
			switch (0) {
#line 563 "BatteryDockItem.c"
				default:
				{
#line 119 "../docklets/Battery/BatteryDockItem.vala"
					break;
#line 568 "BatteryDockItem.c"
				}
			}
		}
#line 122 "../docklets/Battery/BatteryDockItem.vala"
		_tmp22_ = new_icon;
#line 122 "../docklets/Battery/BatteryDockItem.vala"
		plank_dock_item_set_Icon ((PlankDockItem*) self, _tmp22_);
#line 123 "../docklets/Battery/BatteryDockItem.vala"
		_tmp23_ = g_strdup_printf ("%i%%", capacity);
#line 123 "../docklets/Battery/BatteryDockItem.vala"
		_tmp24_ = _tmp23_;
#line 123 "../docklets/Battery/BatteryDockItem.vala"
		plank_dock_element_set_Text ((PlankDockElement*) self, _tmp24_);
#line 123 "../docklets/Battery/BatteryDockItem.vala"
		_g_free0 (_tmp24_);
#line 83 "../docklets/Battery/BatteryDockItem.vala"
		_g_free0 (capacity_level);
#line 83 "../docklets/Battery/BatteryDockItem.vala"
		_g_free0 (_tmp3_);
#line 83 "../docklets/Battery/BatteryDockItem.vala"
		_g_free0 (status);
#line 83 "../docklets/Battery/BatteryDockItem.vala"
		_g_free0 (_tmp0_);
#line 83 "../docklets/Battery/BatteryDockItem.vala"
		_g_free0 (new_icon);
#line 594 "BatteryDockItem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 83 "../docklets/Battery/BatteryDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 125 "../docklets/Battery/BatteryDockItem.vala"
		plank_dock_item_set_Icon ((PlankDockItem*) self, "battery-missing");
#line 126 "../docklets/Battery/BatteryDockItem.vala"
		plank_dock_element_set_Text ((PlankDockElement*) self, _ ("No battery"));
#line 605 "BatteryDockItem.c"
	}
	__finally0:
#line 83 "../docklets/Battery/BatteryDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 610 "BatteryDockItem.c"
		gboolean _tmp25_ = FALSE;
#line 83 "../docklets/Battery/BatteryDockItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "../docklets/Battery/BatteryDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 83 "../docklets/Battery/BatteryDockItem.vala"
		return _tmp25_;
#line 618 "BatteryDockItem.c"
	}
#line 129 "../docklets/Battery/BatteryDockItem.vala"
	result = TRUE;
#line 129 "../docklets/Battery/BatteryDockItem.vala"
	return result;
#line 624 "BatteryDockItem.c"
}

DockyBatteryDockItem*
docky_battery_dock_item_construct (GType object_type)
{
	DockyBatteryDockItem * self = NULL;
#line 24 "../docklets/Battery/BatteryDockItem.vala"
	self = (DockyBatteryDockItem*) plank_docklet_item_construct (object_type);
#line 24 "../docklets/Battery/BatteryDockItem.vala"
	return self;
#line 635 "BatteryDockItem.c"
}

DockyBatteryDockItem*
docky_battery_dock_item_new (void)
{
#line 24 "../docklets/Battery/BatteryDockItem.vala"
	return docky_battery_dock_item_construct (DOCKY_TYPE_BATTERY_DOCK_ITEM);
#line 643 "BatteryDockItem.c"
}

static GObject *
docky_battery_dock_item_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DockyBatteryDockItem * self;
#line 44 "../docklets/Battery/BatteryDockItem.vala"
	parent_class = G_OBJECT_CLASS (docky_battery_dock_item_parent_class);
#line 44 "../docklets/Battery/BatteryDockItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "../docklets/Battery/BatteryDockItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DOCKY_TYPE_BATTERY_DOCK_ITEM, DockyBatteryDockItem);
#line 46 "../docklets/Battery/BatteryDockItem.vala"
	plank_dock_item_set_Icon ((PlankDockItem*) self, "battery-missing");
#line 47 "../docklets/Battery/BatteryDockItem.vala"
	plank_dock_element_set_Text ((PlankDockElement*) self, _ ("No battery"));
#line 48 "../docklets/Battery/BatteryDockItem.vala"
	docky_battery_dock_item_update (self);
#line 50 "../docklets/Battery/BatteryDockItem.vala"
	self->priv->timer_id = gdk_threads_add_timeout ((guint) (60 * 1000), (GSourceFunc) docky_battery_dock_item_update, self);
#line 44 "../docklets/Battery/BatteryDockItem.vala"
	return obj;
#line 670 "BatteryDockItem.c"
}

static void
docky_battery_dock_item_class_init (DockyBatteryDockItemClass * klass,
                                    gpointer klass_data)
{
#line 24 "../docklets/Battery/BatteryDockItem.vala"
	docky_battery_dock_item_parent_class = g_type_class_peek_parent (klass);
#line 24 "../docklets/Battery/BatteryDockItem.vala"
	g_type_class_adjust_private_offset (klass, &DockyBatteryDockItem_private_offset);
#line 24 "../docklets/Battery/BatteryDockItem.vala"
	G_OBJECT_CLASS (klass)->constructor = docky_battery_dock_item_constructor;
#line 24 "../docklets/Battery/BatteryDockItem.vala"
	G_OBJECT_CLASS (klass)->finalize = docky_battery_dock_item_finalize;
#line 685 "BatteryDockItem.c"
}

static void
docky_battery_dock_item_instance_init (DockyBatteryDockItem * self,
                                       gpointer klass)
{
	gchar* _tmp0_;
#line 24 "../docklets/Battery/BatteryDockItem.vala"
	self->priv = docky_battery_dock_item_get_instance_private (self);
#line 33 "../docklets/Battery/BatteryDockItem.vala"
	_tmp0_ = g_strdup ("BAT0");
#line 33 "../docklets/Battery/BatteryDockItem.vala"
	self->priv->current_battery = _tmp0_;
#line 34 "../docklets/Battery/BatteryDockItem.vala"
	self->priv->timer_id = 0U;
#line 701 "BatteryDockItem.c"
}

static void
docky_battery_dock_item_finalize (GObject * obj)
{
	DockyBatteryDockItem * self;
#line 24 "../docklets/Battery/BatteryDockItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DOCKY_TYPE_BATTERY_DOCK_ITEM, DockyBatteryDockItem);
#line 55 "../docklets/Battery/BatteryDockItem.vala"
	if (self->priv->timer_id > 0U) {
#line 56 "../docklets/Battery/BatteryDockItem.vala"
		g_source_remove (self->priv->timer_id);
#line 714 "BatteryDockItem.c"
	}
#line 33 "../docklets/Battery/BatteryDockItem.vala"
	_g_free0 (self->priv->current_battery);
#line 24 "../docklets/Battery/BatteryDockItem.vala"
	G_OBJECT_CLASS (docky_battery_dock_item_parent_class)->finalize (obj);
#line 720 "BatteryDockItem.c"
}

static GType
docky_battery_dock_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DockyBatteryDockItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) docky_battery_dock_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DockyBatteryDockItem), 0, (GInstanceInitFunc) docky_battery_dock_item_instance_init, NULL };
	GType docky_battery_dock_item_type_id;
	docky_battery_dock_item_type_id = g_type_register_static (PLANK_TYPE_DOCKLET_ITEM, "DockyBatteryDockItem", &g_define_type_info, 0);
	DockyBatteryDockItem_private_offset = g_type_add_instance_private (docky_battery_dock_item_type_id, sizeof (DockyBatteryDockItemPrivate));
	return docky_battery_dock_item_type_id;
}

GType
docky_battery_dock_item_get_type (void)
{
	static volatile gsize docky_battery_dock_item_type_id__once = 0;
	if (g_once_init_enter (&docky_battery_dock_item_type_id__once)) {
		GType docky_battery_dock_item_type_id;
		docky_battery_dock_item_type_id = docky_battery_dock_item_get_type_once ();
		g_once_init_leave (&docky_battery_dock_item_type_id__once, docky_battery_dock_item_type_id);
	}
	return docky_battery_dock_item_type_id__once;
}

