/* CPUMonitorDockItem.c generated by valac 0.56.14, the Vala compiler
 * generated from CPUMonitorDockItem.vala, do not modify */

/**/
/*  Copyright (C) 2016 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "docklet-cpumonitor.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include "plank.h"
#include <gdk/gdk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>

#define DOCKY_CPU_MONITOR_DOCK_ITEM_UPDATE_DELAY 1000000UL
#define DOCKY_CPU_MONITOR_DOCK_ITEM_RADIUS_PERCENT 0.9
#define DOCKY_CPU_MONITOR_DOCK_ITEM_CPU_THRESHOLD 0.03
#define DOCKY_CPU_MONITOR_DOCK_ITEM_MEM_THRESHOLD 0.01

enum  {
	DOCKY_CPU_MONITOR_DOCK_ITEM_0_PROPERTY,
	DOCKY_CPU_MONITOR_DOCK_ITEM_NUM_PROPERTIES
};
static GParamSpec* docky_cpu_monitor_dock_item_properties[DOCKY_CPU_MONITOR_DOCK_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

struct _DockyCPUMonitorDockItemPrivate {
	gboolean disposed;
	gulong last_usage;
	gulong last_idle;
	gdouble cpu_utilization;
	gdouble memory_utilization;
	gdouble last_cpu_utilization;
	gdouble last_memory_utilization;
};

static gint DockyCPUMonitorDockItem_private_offset;
static gpointer docky_cpu_monitor_dock_item_parent_class = NULL;

static PlankAnimationType docky_cpu_monitor_dock_item_real_on_clicked (PlankDockElement* base,
                                                                PlankPopupButton button,
                                                                GdkModifierType mod,
                                                                guint32 event_time);
static void docky_cpu_monitor_dock_item_update (DockyCPUMonitorDockItem* self);
static gboolean ___lambda4_ (DockyCPUMonitorDockItem* self);
static gboolean ____lambda4__gsource_func (gpointer self);
static void docky_cpu_monitor_dock_item_real_draw_icon (PlankDockItem* base,
                                                 PlankSurface* surface);
static GObject * docky_cpu_monitor_dock_item_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void* _docky_cpu_monitor_dock_item___lambda5_ (DockyCPUMonitorDockItem* self);
static gpointer __docky_cpu_monitor_dock_item___lambda5__gthread_func (gpointer self);
static void docky_cpu_monitor_dock_item_finalize (GObject * obj);
static GType docky_cpu_monitor_dock_item_get_type_once (void);

static inline gpointer
docky_cpu_monitor_dock_item_get_instance_private (DockyCPUMonitorDockItem* self)
{
	return G_STRUCT_MEMBER_P (self, DockyCPUMonitorDockItem_private_offset);
}

/**
 * {@inheritDoc}
 */
DockyCPUMonitorDockItem*
docky_cpu_monitor_dock_item_construct_with_dockitem_file (GType object_type,
                                                          GFile* file)
{
	DockyCPUMonitorDockItem * self = NULL;
	PlankDockItemPreferences* _tmp0_;
	PlankDockItemPreferences* _tmp1_;
#line 44 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 46 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp0_ = plank_dock_item_preferences_new_with_file (file);
#line 46 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp1_ = _tmp0_;
#line 46 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	self = (DockyCPUMonitorDockItem*) g_object_new (object_type, "Prefs", _tmp1_, NULL);
#line 46 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_g_object_unref0 (_tmp1_);
#line 44 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	return self;
#line 118 "CPUMonitorDockItem.c"
}

DockyCPUMonitorDockItem*
docky_cpu_monitor_dock_item_new_with_dockitem_file (GFile* file)
{
#line 44 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	return docky_cpu_monitor_dock_item_construct_with_dockitem_file (DOCKY_TYPE_CPU_MONITOR_DOCK_ITEM, file);
#line 126 "CPUMonitorDockItem.c"
}

static PlankAnimationType
docky_cpu_monitor_dock_item_real_on_clicked (PlankDockElement* base,
                                             PlankPopupButton button,
                                             GdkModifierType mod,
                                             guint32 event_time)
{
	DockyCPUMonitorDockItem * self;
	PlankAnimationType result;
#line 65 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	self = (DockyCPUMonitorDockItem*) base;
#line 67 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	if (button == PLANK_POPUP_BUTTON_LEFT) {
#line 141 "CPUMonitorDockItem.c"
	}
#line 72 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	result = PLANK_ANIMATION_TYPE_NONE;
#line 72 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	return result;
#line 147 "CPUMonitorDockItem.c"
}

static gboolean
___lambda4_ (DockyCPUMonitorDockItem* self)
{
	gboolean result;
#line 115 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	plank_dock_item_reset_icon_buffer ((PlankDockItem*) self);
#line 116 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	result = FALSE;
#line 116 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	return result;
#line 160 "CPUMonitorDockItem.c"
}

static gboolean
____lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda4_ ((DockyCPUMonitorDockItem*) self);
#line 114 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	return result;
#line 170 "CPUMonitorDockItem.c"
}

static void
docky_cpu_monitor_dock_item_update (DockyCPUMonitorDockItem* self)
{
	FILE* stream = NULL;
	FILE* _tmp0_;
	FILE* _tmp1_;
	FILE* _tmp10_;
	FILE* _tmp11_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_ = FALSE;
#line 75 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	g_return_if_fail (self != NULL);
#line 79 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp0_ = g_fopen ("/proc/stat", "r");
#line 79 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_fclose0 (stream);
#line 79 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	stream = _tmp0_;
#line 80 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp1_ = stream;
#line 80 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	if (_tmp1_ != NULL) {
#line 196 "CPUMonitorDockItem.c"
		gulong user = 0UL;
		gulong nice = 0UL;
		gulong system = 0UL;
		gulong idle = 0UL;
		gulong iowait = 0UL;
		gulong irq = 0UL;
		gulong softirq = 0UL;
		FILE* _tmp2_;
		gulong _tmp3_ = 0UL;
		gulong _tmp4_ = 0UL;
		gulong _tmp5_ = 0UL;
		gulong _tmp6_ = 0UL;
		gulong _tmp7_ = 0UL;
		gulong _tmp8_ = 0UL;
		gulong _tmp9_ = 0UL;
		gulong usage_final = 0UL;
		gulong idle_final = 0UL;
		gulong usage_diff = 0UL;
		gulong idle_diff = 0UL;
#line 82 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		_tmp2_ = stream;
#line 82 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		fscanf (_tmp2_, "%*s %lu %lu %lu %lu %lu %lu %lu", &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 82 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		user = _tmp3_;
#line 82 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		nice = _tmp4_;
#line 82 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		system = _tmp5_;
#line 82 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		idle = _tmp6_;
#line 82 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		iowait = _tmp7_;
#line 82 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		irq = _tmp8_;
#line 82 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		softirq = _tmp9_;
#line 85 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		usage_final = (((((user + nice) + system) + idle) + iowait) + irq) + softirq;
#line 86 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		idle_final = idle + iowait;
#line 88 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		usage_diff = usage_final - self->priv->last_usage;
#line 89 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		idle_diff = idle_final - self->priv->last_idle;
#line 91 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		self->priv->last_idle = idle_final;
#line 92 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		self->priv->last_usage = usage_final;
#line 95 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		if (usage_diff > 0UL) {
#line 96 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
			self->priv->cpu_utilization = MAX (0.01, ((1.0 - (idle_diff / ((gdouble) usage_diff))) + self->priv->cpu_utilization) / 2.0);
#line 250 "CPUMonitorDockItem.c"
		}
	}
#line 99 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp10_ = g_fopen ("/proc/meminfo", "r");
#line 99 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_fclose0 (stream);
#line 99 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	stream = _tmp10_;
#line 100 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp11_ = stream;
#line 100 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	if (_tmp11_ != NULL) {
#line 263 "CPUMonitorDockItem.c"
		gulong mem_total = 0UL;
		gulong mem_free = 0UL;
		gulong mem_avail = 0UL;
		FILE* _tmp12_;
		gulong _tmp13_ = 0UL;
		FILE* _tmp14_;
		gulong _tmp15_ = 0UL;
		FILE* _tmp16_;
		gulong _tmp17_ = 0UL;
#line 102 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		_tmp12_ = stream;
#line 102 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		fscanf (_tmp12_, "%*s %lu %*s", &_tmp13_);
#line 102 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		mem_total = _tmp13_;
#line 103 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		_tmp14_ = stream;
#line 103 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		fscanf (_tmp14_, "%*s %lu %*s", &_tmp15_);
#line 103 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		mem_free = _tmp15_;
#line 104 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		_tmp16_ = stream;
#line 104 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		fscanf (_tmp16_, "%*s %lu %*s", &_tmp17_);
#line 104 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		mem_avail = _tmp17_;
#line 106 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		self->priv->memory_utilization = 1.0 - (mem_avail / ((gdouble) mem_total));
#line 293 "CPUMonitorDockItem.c"
	}
#line 109 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp18_ = g_strdup_printf ("CPU: %.1f%% | Mem: %.1f%%", self->priv->cpu_utilization * 100, self->priv->memory_utilization * 100);
#line 109 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp19_ = _tmp18_;
#line 109 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	plank_dock_element_set_Text ((PlankDockElement*) self, _tmp19_);
#line 109 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_g_free0 (_tmp19_);
#line 112 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	if (fabs (self->priv->last_cpu_utilization - self->priv->cpu_utilization) >= DOCKY_CPU_MONITOR_DOCK_ITEM_CPU_THRESHOLD) {
#line 112 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		_tmp20_ = TRUE;
#line 307 "CPUMonitorDockItem.c"
	} else {
#line 113 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		_tmp20_ = fabs (self->priv->last_memory_utilization - self->priv->memory_utilization) >= DOCKY_CPU_MONITOR_DOCK_ITEM_MEM_THRESHOLD;
#line 311 "CPUMonitorDockItem.c"
	}
#line 112 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	if (_tmp20_) {
#line 114 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda4__gsource_func, g_object_ref (self), g_object_unref);
#line 119 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		self->priv->last_cpu_utilization = self->priv->cpu_utilization;
#line 120 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		self->priv->last_memory_utilization = self->priv->memory_utilization;
#line 321 "CPUMonitorDockItem.c"
	}
#line 75 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_fclose0 (stream);
#line 325 "CPUMonitorDockItem.c"
}

static void
docky_cpu_monitor_dock_item_real_draw_icon (PlankDockItem* base,
                                            PlankSurface* surface)
{
	DockyCPUMonitorDockItem * self;
	gint size = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	cairo_t* cr = NULL;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_pattern_t* pattern = NULL;
	gdouble center = 0.0;
	PlankColor base_color = {0};
	PlankColor _tmp6_ = {0};
	gdouble radius = 0.0;
	cairo_pattern_t* _tmp7_;
	cairo_pattern_t* _tmp8_;
	PlankColor _tmp9_;
	PlankColor _tmp10_;
	PlankColor _tmp11_;
	PlankColor _tmp12_;
	cairo_pattern_t* _tmp13_;
	PlankColor _tmp14_;
	PlankColor _tmp15_;
	PlankColor _tmp16_;
	PlankColor _tmp17_;
	cairo_pattern_t* _tmp18_;
	PlankColor _tmp19_;
	PlankColor _tmp20_;
	PlankColor _tmp21_;
	cairo_pattern_t* _tmp22_;
	cairo_pattern_t* _tmp23_;
	cairo_pattern_t* _tmp24_;
	PlankColor _tmp25_;
	PlankColor _tmp26_;
	PlankColor _tmp27_;
	cairo_pattern_t* _tmp28_;
	PlankColor _tmp29_;
	PlankColor _tmp30_;
	PlankColor _tmp31_;
	cairo_pattern_t* _tmp32_;
	PlankColor _tmp33_;
	PlankColor _tmp34_;
	PlankColor _tmp35_;
	cairo_pattern_t* _tmp36_;
	cairo_pattern_t* _tmp37_;
	cairo_pattern_t* _tmp38_;
	cairo_pattern_t* _tmp39_;
	cairo_pattern_t* _tmp40_;
#line 124 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	self = (DockyCPUMonitorDockItem*) base;
#line 124 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	g_return_if_fail (surface != NULL);
#line 126 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp0_ = plank_surface_get_Width (surface);
#line 126 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp1_ = _tmp0_;
#line 126 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp2_ = plank_surface_get_Height (surface);
#line 126 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp3_ = _tmp2_;
#line 126 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	size = MAX (_tmp1_, _tmp3_);
#line 127 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp4_ = plank_surface_get_Context (surface);
#line 127 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp5_ = _tmp4_;
#line 127 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cr = _tmp5_;
#line 130 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	center = size / 2.0;
#line 131 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp6_.red = 1.0;
#line 131 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp6_.green = 0.3;
#line 131 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp6_.blue = 0.3;
#line 131 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp6_.alpha = 0.5;
#line 131 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	base_color = _tmp6_;
#line 132 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	plank_color_set_hue (&base_color, 120.0 * (1.0 - self->priv->cpu_utilization));
#line 134 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	radius = MAX (MIN (self->priv->cpu_utilization * 1.3, 1.0), 0.001);
#line 137 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_arc (cr, center, center, center * DOCKY_CPU_MONITOR_DOCK_ITEM_RADIUS_PERCENT, 0.0, 2.0 * G_PI);
#line 138 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_set_source_rgba (cr, 0.0, 0.0, 0.0, 0.5);
#line 139 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_fill_preserve (cr);
#line 141 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp7_ = cairo_pattern_create_radial (center, center, 0.0, center, center, center * DOCKY_CPU_MONITOR_DOCK_ITEM_RADIUS_PERCENT);
#line 141 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_cairo_pattern_destroy0 (pattern);
#line 141 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	pattern = _tmp7_;
#line 142 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp8_ = pattern;
#line 142 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp9_ = base_color;
#line 142 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp10_ = base_color;
#line 142 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp11_ = base_color;
#line 142 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp12_ = base_color;
#line 142 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_pattern_add_color_stop_rgba (_tmp8_, 0.0, _tmp9_.red, _tmp10_.green, _tmp11_.blue, _tmp12_.alpha);
#line 143 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp13_ = pattern;
#line 143 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp14_ = base_color;
#line 143 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp15_ = base_color;
#line 143 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp16_ = base_color;
#line 143 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp17_ = base_color;
#line 143 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_pattern_add_color_stop_rgba (_tmp13_, 0.2, _tmp14_.red, _tmp15_.green, _tmp16_.blue, _tmp17_.alpha);
#line 144 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp18_ = pattern;
#line 144 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp19_ = base_color;
#line 144 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp20_ = base_color;
#line 144 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp21_ = base_color;
#line 144 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_pattern_add_color_stop_rgba (_tmp18_, 1.0, _tmp19_.red, _tmp20_.green, _tmp21_.blue, 0.15);
#line 145 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp22_ = pattern;
#line 145 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_set_source (cr, _tmp22_);
#line 146 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_fill_preserve (cr);
#line 149 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp23_ = cairo_pattern_create_radial (center, center, (gdouble) 0, center, center, (center * DOCKY_CPU_MONITOR_DOCK_ITEM_RADIUS_PERCENT) * radius);
#line 149 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_cairo_pattern_destroy0 (pattern);
#line 149 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	pattern = _tmp23_;
#line 150 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp24_ = pattern;
#line 150 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp25_ = base_color;
#line 150 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp26_ = base_color;
#line 150 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp27_ = base_color;
#line 150 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_pattern_add_color_stop_rgba (_tmp24_, 0.0, _tmp25_.red, _tmp26_.green, _tmp27_.blue, 1.0);
#line 151 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp28_ = pattern;
#line 151 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp29_ = base_color;
#line 151 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp30_ = base_color;
#line 151 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp31_ = base_color;
#line 151 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_pattern_add_color_stop_rgba (_tmp28_, 0.2, _tmp29_.red, _tmp30_.green, _tmp31_.blue, 1.0);
#line 152 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp32_ = pattern;
#line 152 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp33_ = base_color;
#line 152 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp34_ = base_color;
#line 152 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp35_ = base_color;
#line 152 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_pattern_add_color_stop_rgba (_tmp32_, 1.0, _tmp33_.red, _tmp34_.green, _tmp35_.blue, MAX (0.0, (self->priv->cpu_utilization * 1.3) - 1.0));
#line 153 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp36_ = pattern;
#line 153 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_set_source (cr, _tmp36_);
#line 154 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_fill (cr);
#line 157 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_arc (cr, center, center * 0.8, center * 0.6, 0.0, 2.0 * G_PI);
#line 158 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp37_ = cairo_pattern_create_linear (0.0, 0.0, 0.0, center);
#line 158 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_cairo_pattern_destroy0 (pattern);
#line 158 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	pattern = _tmp37_;
#line 159 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp38_ = pattern;
#line 159 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_pattern_add_color_stop_rgba (_tmp38_, 0.0, 1.0, 1.0, 1.0, 0.35);
#line 160 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp39_ = pattern;
#line 160 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_pattern_add_color_stop_rgba (_tmp39_, 1.0, 1.0, 1.0, 1.0, 0.0);
#line 161 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp40_ = pattern;
#line 161 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_set_source (cr, _tmp40_);
#line 162 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_fill (cr);
#line 165 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_set_line_width (cr, 1.0);
#line 166 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_arc (cr, center, center, center * DOCKY_CPU_MONITOR_DOCK_ITEM_RADIUS_PERCENT, 0.0, 2.0 * G_PI);
#line 167 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_set_source_rgba (cr, 1.0, 1.0, 1.0, 0.75);
#line 168 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_stroke (cr);
#line 170 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_set_line_width (cr, 1.0);
#line 171 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_arc (cr, center, center, (center * DOCKY_CPU_MONITOR_DOCK_ITEM_RADIUS_PERCENT) - 1.0, 0.0, 2.0 * G_PI);
#line 172 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_set_source_rgba (cr, 0.8, 0.8, 0.8, 0.75);
#line 173 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_stroke (cr);
#line 176 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_set_line_width (cr, size / 32.0);
#line 177 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_arc_negative (cr, center, center, (center * DOCKY_CPU_MONITOR_DOCK_ITEM_RADIUS_PERCENT) - 1.0, G_PI, G_PI - (G_PI * (2.0 * self->priv->memory_utilization)));
#line 178 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_set_source_rgba (cr, 1.0, 1.0, 1.0, 0.85);
#line 179 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	cairo_stroke (cr);
#line 124 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_cairo_pattern_destroy0 (pattern);
#line 558 "CPUMonitorDockItem.c"
}

DockyCPUMonitorDockItem*
docky_cpu_monitor_dock_item_construct (GType object_type)
{
	DockyCPUMonitorDockItem * self = NULL;
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	self = (DockyCPUMonitorDockItem*) plank_docklet_item_construct (object_type);
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	return self;
#line 569 "CPUMonitorDockItem.c"
}

DockyCPUMonitorDockItem*
docky_cpu_monitor_dock_item_new (void)
{
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	return docky_cpu_monitor_dock_item_construct (DOCKY_TYPE_CPU_MONITOR_DOCK_ITEM);
#line 577 "CPUMonitorDockItem.c"
}

static void*
_docky_cpu_monitor_dock_item___lambda5_ (DockyCPUMonitorDockItem* self)
{
	void* result;
#line 52 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	while (TRUE) {
#line 52 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		if (!(!self->priv->disposed)) {
#line 52 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
			break;
#line 590 "CPUMonitorDockItem.c"
		}
#line 53 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		docky_cpu_monitor_dock_item_update (self);
#line 54 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
		g_usleep (DOCKY_CPU_MONITOR_DOCK_ITEM_UPDATE_DELAY);
#line 596 "CPUMonitorDockItem.c"
	}
#line 56 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	result = NULL;
#line 56 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	return result;
#line 602 "CPUMonitorDockItem.c"
}

static gpointer
__docky_cpu_monitor_dock_item___lambda5__gthread_func (gpointer self)
{
	gpointer result;
	result = _docky_cpu_monitor_dock_item___lambda5_ ((DockyCPUMonitorDockItem*) self);
#line 51 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	g_object_unref (self);
#line 51 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	return result;
#line 614 "CPUMonitorDockItem.c"
}

static GObject *
docky_cpu_monitor_dock_item_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DockyCPUMonitorDockItem * self;
	GThread* _tmp0_;
	GThread* _tmp1_;
#line 49 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	parent_class = G_OBJECT_CLASS (docky_cpu_monitor_dock_item_parent_class);
#line 49 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 49 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DOCKY_TYPE_CPU_MONITOR_DOCK_ITEM, DockyCPUMonitorDockItem);
#line 51 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp0_ = g_thread_new (NULL, __docky_cpu_monitor_dock_item___lambda5__gthread_func, g_object_ref (self));
#line 51 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_tmp1_ = _tmp0_;
#line 51 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	_g_thread_unref0 (_tmp1_);
#line 49 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	return obj;
#line 641 "CPUMonitorDockItem.c"
}

static void
docky_cpu_monitor_dock_item_class_init (DockyCPUMonitorDockItemClass * klass,
                                        gpointer klass_data)
{
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	docky_cpu_monitor_dock_item_parent_class = g_type_class_peek_parent (klass);
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	g_type_class_adjust_private_offset (klass, &DockyCPUMonitorDockItem_private_offset);
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	((PlankDockElementClass *) klass)->on_clicked = (PlankAnimationType (*) (PlankDockElement*, PlankPopupButton, GdkModifierType, guint32)) docky_cpu_monitor_dock_item_real_on_clicked;
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	((PlankDockItemClass *) klass)->draw_icon = (void (*) (PlankDockItem*, PlankSurface*)) docky_cpu_monitor_dock_item_real_draw_icon;
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	G_OBJECT_CLASS (klass)->constructor = docky_cpu_monitor_dock_item_constructor;
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	G_OBJECT_CLASS (klass)->finalize = docky_cpu_monitor_dock_item_finalize;
#line 660 "CPUMonitorDockItem.c"
}

static void
docky_cpu_monitor_dock_item_instance_init (DockyCPUMonitorDockItem * self,
                                           gpointer klass)
{
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	self->priv = docky_cpu_monitor_dock_item_get_instance_private (self);
#line 31 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	self->priv->disposed = FALSE;
#line 671 "CPUMonitorDockItem.c"
}

static void
docky_cpu_monitor_dock_item_finalize (GObject * obj)
{
	DockyCPUMonitorDockItem * self;
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DOCKY_TYPE_CPU_MONITOR_DOCK_ITEM, DockyCPUMonitorDockItem);
#line 62 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	self->priv->disposed = TRUE;
#line 24 "../docklets/CPUMonitor/CPUMonitorDockItem.vala"
	G_OBJECT_CLASS (docky_cpu_monitor_dock_item_parent_class)->finalize (obj);
#line 684 "CPUMonitorDockItem.c"
}

static GType
docky_cpu_monitor_dock_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DockyCPUMonitorDockItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) docky_cpu_monitor_dock_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DockyCPUMonitorDockItem), 0, (GInstanceInitFunc) docky_cpu_monitor_dock_item_instance_init, NULL };
	GType docky_cpu_monitor_dock_item_type_id;
	docky_cpu_monitor_dock_item_type_id = g_type_register_static (PLANK_TYPE_DOCKLET_ITEM, "DockyCPUMonitorDockItem", &g_define_type_info, 0);
	DockyCPUMonitorDockItem_private_offset = g_type_add_instance_private (docky_cpu_monitor_dock_item_type_id, sizeof (DockyCPUMonitorDockItemPrivate));
	return docky_cpu_monitor_dock_item_type_id;
}

GType
docky_cpu_monitor_dock_item_get_type (void)
{
	static volatile gsize docky_cpu_monitor_dock_item_type_id__once = 0;
	if (g_once_init_enter (&docky_cpu_monitor_dock_item_type_id__once)) {
		GType docky_cpu_monitor_dock_item_type_id;
		docky_cpu_monitor_dock_item_type_id = docky_cpu_monitor_dock_item_get_type_once ();
		g_once_init_leave (&docky_cpu_monitor_dock_item_type_id__once, docky_cpu_monitor_dock_item_type_id);
	}
	return docky_cpu_monitor_dock_item_type_id__once;
}

