/* DockController.c generated by valac 0.56.14, the Vala compiler
 * generated from DockController.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "plank.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "plank-internal.h"

enum  {
	PLANK_DOCK_CONTROLLER_0_PROPERTY,
	PLANK_DOCK_CONTROLLER_NAME_PROPERTY,
	PLANK_DOCK_CONTROLLER_CONFIG_FOLDER_PROPERTY,
	PLANK_DOCK_CONTROLLER_LAUNCHERS_FOLDER_PROPERTY,
	PLANK_DOCK_CONTROLLER_PREFS_PROPERTY,
	PLANK_DOCK_CONTROLLER_DRAG_MANAGER_PROPERTY,
	PLANK_DOCK_CONTROLLER_HIDE_MANAGER_PROPERTY,
	PLANK_DOCK_CONTROLLER_POSITION_MANAGER_PROPERTY,
	PLANK_DOCK_CONTROLLER_RENDERER_PROPERTY,
	PLANK_DOCK_CONTROLLER_WINDOW_PROPERTY,
	PLANK_DOCK_CONTROLLER_HOVER_PROPERTY,
	PLANK_DOCK_CONTROLLER_DEFAULT_PROVIDER_PROPERTY,
	PLANK_DOCK_CONTROLLER_ITEMS_PROPERTY,
	PLANK_DOCK_CONTROLLER_VISIBLE_ITEMS_PROPERTY,
	PLANK_DOCK_CONTROLLER_NUM_PROPERTIES
};
static GParamSpec* plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _PlankDockControllerPrivate {
	gchar* _name;
	GFile* _config_folder;
	GFile* _launchers_folder;
	PlankDockPreferences* _prefs;
	PlankDragManager* _drag_manager;
	PlankHideManager* _hide_manager;
	PlankPositionManager* _position_manager;
	PlankDockRenderer* _renderer;
	PlankDockWindow* _window;
	PlankHoverWindow* _hover;
	PlankDockItemProvider* _default_provider;
	PlankDBusManager* dbus_manager;
	GeeArrayList* visible_items;
	GeeArrayList* items;
	PlankDockItem* dock_itself_item;
	guint serialize_item_positions_timer_id;
};

static gint PlankDockController_private_offset;
static gpointer plank_dock_controller_parent_class = NULL;

static void _plank_dock_container_update_visible_elements_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void plank_dock_controller_update_show_dock_item (PlankDockController* self);
static void _plank_dock_controller_update_show_dock_item_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void plank_dock_controller_handle_positions_changed (PlankDockController* self,
                                                     PlankDockContainer* container,
                                                     GeeList* moved_items);
static void _plank_dock_controller_handle_positions_changed_plank_dock_container_positions_changed (PlankDockContainer* _sender,
                                                                                             GeeList* elements,
                                                                                             gpointer self);
static void plank_dock_controller_handle_states_changed (PlankDockController* self,
                                                  PlankDockContainer* container);
static void _plank_dock_controller_handle_states_changed_plank_dock_container_states_changed (PlankDockContainer* _sender,
                                                                                       gpointer self);
static void plank_dock_controller_handle_elements_changed (PlankDockController* self,
                                                    PlankDockContainer* container,
                                                    GeeList* added,
                                                    GeeList* removed);
static void _plank_dock_controller_handle_elements_changed_plank_dock_container_elements_changed (PlankDockContainer* _sender,
                                                                                           GeeList* added,
                                                                                           GeeList* removed,
                                                                                           gpointer self);
static gboolean plank_dock_controller_serialize_item_positions (PlankDockController* self);
static void plank_dock_controller_update_items (PlankDockController* self);
static PlankDockItemProvider* plank_dock_controller_create_default_provider (PlankDockController* self);
static void plank_dock_controller_set_default_provider (PlankDockController* self,
                                                 PlankDockItemProvider* value);
static void plank_dock_controller_schedule_serialize_item_positions (PlankDockController* self);
static void plank_dock_controller_real_connect_element (PlankDockContainer* base,
                                                 PlankDockElement* element);
static void _plank_dock_window_update_icon_region_plank_application_dock_item_provider_item_window_added (PlankApplicationDockItemProvider* _sender,
                                                                                                   PlankApplicationDockItem* item,
                                                                                                   gpointer self);
static void plank_dock_controller_real_disconnect_element (PlankDockContainer* base,
                                                    PlankDockElement* element);
static void plank_dock_controller_real_update_visible_elements (PlankDockContainer* base);
static void plank_dock_controller_update_visible_items_recursive (PlankDockController* self,
                                                           PlankDockContainer* container,
                                                           gint* current_position);
static inline void plank_dock_controller_update_visible_items_add_from_iterator (PlankDockController* self,
                                                                   GeeIterator* iterator,
                                                                   gint* current_position);
static void plank_dock_controller_set_launchers_folder (PlankDockController* self,
                                                 GFile* value);
static GObject * plank_dock_controller_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void plank_dock_controller_finalize (GObject * obj);
static GType plank_dock_controller_get_type_once (void);
static void _vala_plank_dock_controller_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_plank_dock_controller_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
plank_dock_controller_get_instance_private (PlankDockController* self)
{
	return G_STRUCT_MEMBER_P (self, PlankDockController_private_offset);
}

static void
_plank_dock_container_update_visible_elements_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 108 "../lib/DockController.vala"
	plank_dock_container_update_visible_elements ((PlankDockContainer*) self);
#line 164 "DockController.c"
}

static void
_plank_dock_controller_update_show_dock_item_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 109 "../lib/DockController.vala"
	plank_dock_controller_update_show_dock_item ((PlankDockController*) self);
#line 174 "DockController.c"
}

static void
_plank_dock_controller_handle_positions_changed_plank_dock_container_positions_changed (PlankDockContainer* _sender,
                                                                                        GeeList* elements,
                                                                                        gpointer self)
{
#line 111 "../lib/DockController.vala"
	plank_dock_controller_handle_positions_changed ((PlankDockController*) self, _sender, elements);
#line 184 "DockController.c"
}

static void
_plank_dock_controller_handle_states_changed_plank_dock_container_states_changed (PlankDockContainer* _sender,
                                                                                  gpointer self)
{
#line 112 "../lib/DockController.vala"
	plank_dock_controller_handle_states_changed ((PlankDockController*) self, _sender);
#line 193 "DockController.c"
}

static void
_plank_dock_controller_handle_elements_changed_plank_dock_container_elements_changed (PlankDockContainer* _sender,
                                                                                      GeeList* added,
                                                                                      GeeList* removed,
                                                                                      gpointer self)
{
#line 113 "../lib/DockController.vala"
	plank_dock_controller_handle_elements_changed ((PlankDockController*) self, _sender, added, removed);
#line 204 "DockController.c"
}

/**
 * Create a new DockController which manages a single dock
 *
 * @param config_folder the base-folder to load settings from and save them to
 */
PlankDockController*
plank_dock_controller_construct (GType object_type,
                                 const gchar* dock_name,
                                 GFile* config_folder)
{
	PlankDockController * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockPreferences* _tmp3_;
#line 75 "../lib/DockController.vala"
	g_return_val_if_fail (dock_name != NULL, NULL);
#line 75 "../lib/DockController.vala"
	g_return_val_if_fail (config_folder != NULL, NULL);
#line 78 "../lib/DockController.vala"
	plank_paths_ensure_directory_exists (config_folder);
#line 80 "../lib/DockController.vala"
	_tmp0_ = g_file_get_path (config_folder);
#line 80 "../lib/DockController.vala"
	_tmp1_ = _tmp0_;
#line 80 "../lib/DockController.vala"
	g_debug ("DockController.vala:80: Create dock '%s' (config_folder = %s)", dock_name, _tmp1_);
#line 80 "../lib/DockController.vala"
	_g_free0 (_tmp1_);
#line 82 "../lib/DockController.vala"
	_tmp2_ = plank_dock_preferences_new (dock_name);
#line 82 "../lib/DockController.vala"
	_tmp3_ = _tmp2_;
#line 82 "../lib/DockController.vala"
	self = (PlankDockController*) g_object_new (object_type, "name", dock_name, "config-folder", config_folder, "prefs", _tmp3_, NULL);
#line 82 "../lib/DockController.vala"
	_g_object_unref0 (_tmp3_);
#line 75 "../lib/DockController.vala"
	return self;
#line 246 "DockController.c"
}

PlankDockController*
plank_dock_controller_new (const gchar* dock_name,
                           GFile* config_folder)
{
#line 75 "../lib/DockController.vala"
	return plank_dock_controller_construct (PLANK_TYPE_DOCK_CONTROLLER, dock_name, config_folder);
#line 255 "DockController.c"
}

/**
 * Initialize this controller.
 * Call this when added at least one DockItemProvider otherwise the
 * {@link Plank.DefaultApplicationDockItemProvider} will be added by default.
 */
void
plank_dock_controller_initialize (PlankDockController* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	PlankPositionManager* _tmp3_;
	PlankDragManager* _tmp4_;
	PlankHideManager* _tmp5_;
	PlankDockRenderer* _tmp6_;
	PlankDockWindow* _tmp7_;
#line 128 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 130 "../lib/DockController.vala"
	_tmp0_ = ((PlankDockContainer*) self)->internal_elements;
#line 130 "../lib/DockController.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 130 "../lib/DockController.vala"
	_tmp2_ = _tmp1_;
#line 130 "../lib/DockController.vala"
	if (_tmp2_ <= 0) {
#line 131 "../lib/DockController.vala"
		plank_dock_controller_add_default_provider (self);
#line 286 "DockController.c"
	}
#line 133 "../lib/DockController.vala"
	plank_dock_controller_update_show_dock_item (self);
#line 134 "../lib/DockController.vala"
	plank_dock_controller_update_items (self);
#line 136 "../lib/DockController.vala"
	plank_dock_element_set_AddTime ((PlankDockElement*) self, g_get_monotonic_time ());
#line 138 "../lib/DockController.vala"
	g_signal_connect_object ((PlankDockContainer*) self, "positions-changed", (GCallback) _plank_dock_controller_handle_positions_changed_plank_dock_container_positions_changed, self, 0);
#line 139 "../lib/DockController.vala"
	g_signal_connect_object ((PlankDockContainer*) self, "states-changed", (GCallback) _plank_dock_controller_handle_states_changed_plank_dock_container_states_changed, self, 0);
#line 140 "../lib/DockController.vala"
	g_signal_connect_object ((PlankDockContainer*) self, "elements-changed", (GCallback) _plank_dock_controller_handle_elements_changed_plank_dock_container_elements_changed, self, 0);
#line 142 "../lib/DockController.vala"
	_tmp3_ = self->priv->_position_manager;
#line 142 "../lib/DockController.vala"
	plank_position_manager_initialize (_tmp3_);
#line 143 "../lib/DockController.vala"
	_tmp4_ = self->priv->_drag_manager;
#line 143 "../lib/DockController.vala"
	plank_drag_manager_initialize (_tmp4_);
#line 144 "../lib/DockController.vala"
	_tmp5_ = self->priv->_hide_manager;
#line 144 "../lib/DockController.vala"
	plank_hide_manager_initialize (_tmp5_);
#line 145 "../lib/DockController.vala"
	_tmp6_ = self->priv->_renderer;
#line 145 "../lib/DockController.vala"
	plank_dock_renderer_initialize (_tmp6_);
#line 147 "../lib/DockController.vala"
	_tmp7_ = self->priv->_window;
#line 147 "../lib/DockController.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp7_);
#line 320 "DockController.c"
}

/**
 * Add the default provider which is an instance of
 * {@link Plank.DefaultApplicationDockItemProvider}
 */
void
plank_dock_controller_add_default_provider (PlankDockController* self)
{
	PlankDockItemProvider* _tmp0_;
	PlankDockItemProvider* _tmp1_;
	PlankDockItemProvider* _tmp2_;
	GeeArrayList* elements = NULL;
	PlankItemFactory* _tmp3_;
	GFile* _tmp4_;
	PlankDockPreferences* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_ = 0;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GeeArrayList* _tmp9_;
	gboolean has_default_provider = FALSE;
#line 154 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 156 "../lib/DockController.vala"
	_tmp0_ = self->priv->_default_provider;
#line 156 "../lib/DockController.vala"
	if (_tmp0_ != NULL) {
#line 157 "../lib/DockController.vala"
		return;
#line 352 "DockController.c"
	}
#line 159 "../lib/DockController.vala"
	plank_logger_verbose ("DockController.add_default_provider ()", NULL);
#line 160 "../lib/DockController.vala"
	_tmp1_ = plank_dock_controller_create_default_provider (self);
#line 160 "../lib/DockController.vala"
	_tmp2_ = _tmp1_;
#line 160 "../lib/DockController.vala"
	plank_dock_controller_set_default_provider (self, _tmp2_);
#line 160 "../lib/DockController.vala"
	_g_object_unref0 (_tmp2_);
#line 162 "../lib/DockController.vala"
	_tmp3_ = plank_factory_item_factory;
#line 162 "../lib/DockController.vala"
	_tmp4_ = self->priv->_launchers_folder;
#line 162 "../lib/DockController.vala"
	_tmp5_ = self->priv->_prefs;
#line 162 "../lib/DockController.vala"
	_tmp6_ = plank_dock_preferences_get_DockItems (_tmp5_, &_tmp7_);
#line 162 "../lib/DockController.vala"
	_tmp6__length1 = _tmp7_;
#line 162 "../lib/DockController.vala"
	_tmp8_ = _tmp6_;
#line 162 "../lib/DockController.vala"
	_tmp8__length1 = _tmp6__length1;
#line 162 "../lib/DockController.vala"
	_tmp9_ = plank_item_factory_load_elements (_tmp3_, _tmp4_, _tmp8_, (gint) _tmp8__length1);
#line 162 "../lib/DockController.vala"
	elements = _tmp9_;
#line 382 "DockController.c"
	{
		GeeArrayList* _element_list = NULL;
		GeeArrayList* _tmp10_;
		gint _element_size = 0;
		GeeArrayList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _element_index = 0;
#line 164 "../lib/DockController.vala"
		_tmp10_ = elements;
#line 164 "../lib/DockController.vala"
		_element_list = _tmp10_;
#line 164 "../lib/DockController.vala"
		_tmp11_ = _element_list;
#line 164 "../lib/DockController.vala"
		_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 164 "../lib/DockController.vala"
		_tmp13_ = _tmp12_;
#line 164 "../lib/DockController.vala"
		_element_size = _tmp13_;
#line 164 "../lib/DockController.vala"
		_element_index = -1;
#line 164 "../lib/DockController.vala"
		while (TRUE) {
#line 407 "DockController.c"
			gint _tmp14_;
			gint _tmp15_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp16_;
			gpointer _tmp17_;
			PlankDockElement* _tmp18_;
#line 164 "../lib/DockController.vala"
			_element_index = _element_index + 1;
#line 164 "../lib/DockController.vala"
			_tmp14_ = _element_index;
#line 164 "../lib/DockController.vala"
			_tmp15_ = _element_size;
#line 164 "../lib/DockController.vala"
			if (!(_tmp14_ < _tmp15_)) {
#line 164 "../lib/DockController.vala"
				break;
#line 424 "DockController.c"
			}
#line 164 "../lib/DockController.vala"
			_tmp16_ = _element_list;
#line 164 "../lib/DockController.vala"
			_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _element_index);
#line 164 "../lib/DockController.vala"
			element = (PlankDockElement*) _tmp17_;
#line 165 "../lib/DockController.vala"
			_tmp18_ = element;
#line 165 "../lib/DockController.vala"
			if (PLANK_IS_DOCK_ITEM (_tmp18_)) {
#line 436 "DockController.c"
				PlankDockItemProvider* _tmp19_;
				PlankDockElement* _tmp20_;
#line 166 "../lib/DockController.vala"
				_tmp19_ = self->priv->_default_provider;
#line 166 "../lib/DockController.vala"
				_tmp20_ = element;
#line 166 "../lib/DockController.vala"
				plank_dock_container_add ((PlankDockContainer*) _tmp19_, _tmp20_, NULL);
#line 445 "DockController.c"
			}
#line 164 "../lib/DockController.vala"
			_g_object_unref0 (element);
#line 449 "DockController.c"
		}
	}
#line 168 "../lib/DockController.vala"
	has_default_provider = FALSE;
#line 454 "DockController.c"
	{
		GeeArrayList* _element_list = NULL;
		GeeArrayList* _tmp21_;
		gint _element_size = 0;
		GeeArrayList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gint _element_index = 0;
#line 169 "../lib/DockController.vala"
		_tmp21_ = elements;
#line 169 "../lib/DockController.vala"
		_element_list = _tmp21_;
#line 169 "../lib/DockController.vala"
		_tmp22_ = _element_list;
#line 169 "../lib/DockController.vala"
		_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 169 "../lib/DockController.vala"
		_tmp24_ = _tmp23_;
#line 169 "../lib/DockController.vala"
		_element_size = _tmp24_;
#line 169 "../lib/DockController.vala"
		_element_index = -1;
#line 169 "../lib/DockController.vala"
		while (TRUE) {
#line 479 "DockController.c"
			gint _tmp25_;
			gint _tmp26_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp27_;
			gpointer _tmp28_;
			gboolean _tmp29_ = FALSE;
#line 169 "../lib/DockController.vala"
			_element_index = _element_index + 1;
#line 169 "../lib/DockController.vala"
			_tmp25_ = _element_index;
#line 169 "../lib/DockController.vala"
			_tmp26_ = _element_size;
#line 169 "../lib/DockController.vala"
			if (!(_tmp25_ < _tmp26_)) {
#line 169 "../lib/DockController.vala"
				break;
#line 496 "DockController.c"
			}
#line 169 "../lib/DockController.vala"
			_tmp27_ = _element_list;
#line 169 "../lib/DockController.vala"
			_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _element_index);
#line 169 "../lib/DockController.vala"
			element = (PlankDockElement*) _tmp28_;
#line 170 "../lib/DockController.vala"
			if (!has_default_provider) {
#line 506 "DockController.c"
				PlankDockElement* _tmp30_;
#line 170 "../lib/DockController.vala"
				_tmp30_ = element;
#line 170 "../lib/DockController.vala"
				_tmp29_ = PLANK_IS_DOCK_ITEM (_tmp30_);
#line 512 "DockController.c"
			} else {
#line 170 "../lib/DockController.vala"
				_tmp29_ = FALSE;
#line 516 "DockController.c"
			}
#line 170 "../lib/DockController.vala"
			if (_tmp29_) {
#line 520 "DockController.c"
				PlankDockItemProvider* _tmp31_;
#line 171 "../lib/DockController.vala"
				_tmp31_ = self->priv->_default_provider;
#line 171 "../lib/DockController.vala"
				plank_dock_container_add ((PlankDockContainer*) self, (PlankDockElement*) _tmp31_, NULL);
#line 172 "../lib/DockController.vala"
				has_default_provider = TRUE;
#line 528 "DockController.c"
			} else {
				PlankDockElement* _tmp32_;
#line 173 "../lib/DockController.vala"
				_tmp32_ = element;
#line 173 "../lib/DockController.vala"
				if (PLANK_IS_DOCK_ITEM_PROVIDER (_tmp32_)) {
#line 535 "DockController.c"
					PlankDockElement* _tmp33_;
#line 174 "../lib/DockController.vala"
					_tmp33_ = element;
#line 174 "../lib/DockController.vala"
					plank_dock_container_add ((PlankDockContainer*) self, _tmp33_, NULL);
#line 541 "DockController.c"
				}
			}
#line 169 "../lib/DockController.vala"
			_g_object_unref0 (element);
#line 546 "DockController.c"
		}
	}
#line 177 "../lib/DockController.vala"
	if (!has_default_provider) {
#line 551 "DockController.c"
		PlankDockItemProvider* _tmp34_;
#line 178 "../lib/DockController.vala"
		_tmp34_ = self->priv->_default_provider;
#line 178 "../lib/DockController.vala"
		plank_dock_container_add ((PlankDockContainer*) self, (PlankDockElement*) _tmp34_, NULL);
#line 557 "DockController.c"
	}
#line 180 "../lib/DockController.vala"
	plank_dock_controller_schedule_serialize_item_positions (self);
#line 154 "../lib/DockController.vala"
	_g_object_unref0 (elements);
#line 563 "DockController.c"
}

static PlankDockItemProvider*
plank_dock_controller_create_default_provider (PlankDockController* self)
{
	PlankDockItemProvider* provider = NULL;
	GFile* _tmp0_;
	PlankDockPreferences* _tmp2_;
	GFile* _tmp3_;
	PlankDefaultApplicationDockItemProvider* _tmp4_;
	PlankDockItemProvider* result;
#line 183 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 189 "../lib/DockController.vala"
	_tmp0_ = self->priv->_launchers_folder;
#line 189 "../lib/DockController.vala"
	if (plank_paths_ensure_directory_exists (_tmp0_)) {
#line 581 "DockController.c"
		PlankItemFactory* _tmp1_;
#line 190 "../lib/DockController.vala"
		g_debug ("DockController.vala:190: Adding default dock items...");
#line 191 "../lib/DockController.vala"
		_tmp1_ = plank_factory_item_factory;
#line 191 "../lib/DockController.vala"
		plank_item_factory_make_default_items (_tmp1_);
#line 192 "../lib/DockController.vala"
		g_debug ("DockController.vala:192: done.");
#line 591 "DockController.c"
	}
#line 195 "../lib/DockController.vala"
	_tmp2_ = self->priv->_prefs;
#line 195 "../lib/DockController.vala"
	_tmp3_ = self->priv->_launchers_folder;
#line 195 "../lib/DockController.vala"
	_tmp4_ = plank_default_application_dock_item_provider_new (_tmp2_, _tmp3_);
#line 195 "../lib/DockController.vala"
	_g_object_unref0 (provider);
#line 195 "../lib/DockController.vala"
	provider = (PlankDockItemProvider*) _tmp4_;
#line 197 "../lib/DockController.vala"
	result = provider;
#line 197 "../lib/DockController.vala"
	return result;
#line 607 "DockController.c"
}

static void
plank_dock_controller_update_show_dock_item (PlankDockController* self)
{
	PlankDockPreferences* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 200 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 202 "../lib/DockController.vala"
	_tmp0_ = self->priv->_prefs;
#line 202 "../lib/DockController.vala"
	_tmp1_ = plank_dock_preferences_get_ShowDockItem (_tmp0_);
#line 202 "../lib/DockController.vala"
	_tmp2_ = _tmp1_;
#line 202 "../lib/DockController.vala"
	if (_tmp2_) {
#line 626 "DockController.c"
		PlankDockItem* _tmp3_;
		GeeArrayList* _tmp6_;
		PlankDockItem* _tmp7_;
#line 203 "../lib/DockController.vala"
		_tmp3_ = self->priv->dock_itself_item;
#line 203 "../lib/DockController.vala"
		if (_tmp3_ == NULL) {
#line 634 "DockController.c"
			PlankItemFactory* _tmp4_;
			PlankDockItem* _tmp5_;
#line 204 "../lib/DockController.vala"
			_tmp4_ = plank_factory_item_factory;
#line 204 "../lib/DockController.vala"
			_tmp5_ = plank_item_factory_get_item_for_dock (_tmp4_);
#line 204 "../lib/DockController.vala"
			_g_object_unref0 (self->priv->dock_itself_item);
#line 204 "../lib/DockController.vala"
			self->priv->dock_itself_item = _tmp5_;
#line 645 "DockController.c"
		}
#line 205 "../lib/DockController.vala"
		_tmp6_ = ((PlankDockContainer*) self)->internal_elements;
#line 205 "../lib/DockController.vala"
		_tmp7_ = self->priv->dock_itself_item;
#line 205 "../lib/DockController.vala"
		if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp6_, (PlankDockElement*) _tmp7_)) {
#line 653 "DockController.c"
			PlankDockItem* _tmp8_;
#line 206 "../lib/DockController.vala"
			_tmp8_ = self->priv->dock_itself_item;
#line 206 "../lib/DockController.vala"
			plank_dock_container_prepend ((PlankDockContainer*) self, (PlankDockElement*) _tmp8_);
#line 659 "DockController.c"
		}
	} else {
		PlankDockItem* _tmp9_;
#line 207 "../lib/DockController.vala"
		_tmp9_ = self->priv->dock_itself_item;
#line 207 "../lib/DockController.vala"
		if (_tmp9_ != NULL) {
#line 667 "DockController.c"
			GeeArrayList* _tmp10_;
			PlankDockItem* _tmp11_;
#line 208 "../lib/DockController.vala"
			_tmp10_ = ((PlankDockContainer*) self)->internal_elements;
#line 208 "../lib/DockController.vala"
			_tmp11_ = self->priv->dock_itself_item;
#line 208 "../lib/DockController.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp10_, (PlankDockElement*) _tmp11_)) {
#line 676 "DockController.c"
				PlankDockItem* _tmp12_;
#line 209 "../lib/DockController.vala"
				_tmp12_ = self->priv->dock_itself_item;
#line 209 "../lib/DockController.vala"
				plank_dock_container_remove ((PlankDockContainer*) self, (PlankDockElement*) _tmp12_);
#line 682 "DockController.c"
			}
#line 210 "../lib/DockController.vala"
			_g_object_unref0 (self->priv->dock_itself_item);
#line 210 "../lib/DockController.vala"
			self->priv->dock_itself_item = NULL;
#line 688 "DockController.c"
		}
	}
}

static void
_plank_dock_window_update_icon_region_plank_application_dock_item_provider_item_window_added (PlankApplicationDockItemProvider* _sender,
                                                                                              PlankApplicationDockItem* item,
                                                                                              gpointer self)
{
#line 226 "../lib/DockController.vala"
	plank_dock_window_update_icon_region ((PlankDockWindow*) self, item);
#line 700 "DockController.c"
}

static void
plank_dock_controller_real_connect_element (PlankDockContainer* base,
                                            PlankDockElement* element)
{
	PlankDockController * self;
	PlankDockItemProvider* provider = NULL;
	PlankDockItemProvider* _tmp0_;
	PlankDockItemProvider* _tmp1_;
	PlankDockItemProvider* _tmp2_;
	PlankDockItemProvider* _tmp3_;
	PlankApplicationDockItemProvider* app_provider = NULL;
	PlankDockItemProvider* _tmp4_;
	PlankApplicationDockItemProvider* _tmp5_;
#line 214 "../lib/DockController.vala"
	self = (PlankDockController*) base;
#line 214 "../lib/DockController.vala"
	g_return_if_fail (element != NULL);
#line 216 "../lib/DockController.vala"
	provider = PLANK_IS_DOCK_ITEM_PROVIDER (element) ? ((PlankDockItemProvider*) element) : NULL;
#line 217 "../lib/DockController.vala"
	_tmp0_ = provider;
#line 217 "../lib/DockController.vala"
	if (_tmp0_ == NULL) {
#line 218 "../lib/DockController.vala"
		return;
#line 728 "DockController.c"
	}
#line 220 "../lib/DockController.vala"
	_tmp1_ = provider;
#line 220 "../lib/DockController.vala"
	g_signal_connect_object ((PlankDockContainer*) _tmp1_, "positions-changed", (GCallback) _plank_dock_controller_handle_positions_changed_plank_dock_container_positions_changed, self, 0);
#line 221 "../lib/DockController.vala"
	_tmp2_ = provider;
#line 221 "../lib/DockController.vala"
	g_signal_connect_object ((PlankDockContainer*) _tmp2_, "states-changed", (GCallback) _plank_dock_controller_handle_states_changed_plank_dock_container_states_changed, self, 0);
#line 222 "../lib/DockController.vala"
	_tmp3_ = provider;
#line 222 "../lib/DockController.vala"
	g_signal_connect_object ((PlankDockContainer*) _tmp3_, "elements-changed", (GCallback) _plank_dock_controller_handle_elements_changed_plank_dock_container_elements_changed, self, 0);
#line 224 "../lib/DockController.vala"
	_tmp4_ = provider;
#line 224 "../lib/DockController.vala"
	app_provider = PLANK_IS_APPLICATION_DOCK_ITEM_PROVIDER (_tmp4_) ? ((PlankApplicationDockItemProvider*) _tmp4_) : NULL;
#line 225 "../lib/DockController.vala"
	_tmp5_ = app_provider;
#line 225 "../lib/DockController.vala"
	if (_tmp5_ != NULL) {
#line 750 "DockController.c"
		PlankApplicationDockItemProvider* _tmp6_;
		PlankDockWindow* _tmp7_;
		PlankUnity* _tmp8_;
		PlankApplicationDockItemProvider* _tmp9_;
#line 226 "../lib/DockController.vala"
		_tmp6_ = app_provider;
#line 226 "../lib/DockController.vala"
		_tmp7_ = self->priv->_window;
#line 226 "../lib/DockController.vala"
		g_signal_connect_object (_tmp6_, "item-window-added", (GCallback) _plank_dock_window_update_icon_region_plank_application_dock_item_provider_item_window_added, _tmp7_, 0);
#line 227 "../lib/DockController.vala"
		_tmp8_ = plank_unity_get_default ();
#line 227 "../lib/DockController.vala"
		_tmp9_ = app_provider;
#line 227 "../lib/DockController.vala"
		plank_unity_add_client (_tmp8_, (PlankUnityClient*) _tmp9_);
#line 767 "DockController.c"
	}
}

static void
plank_dock_controller_real_disconnect_element (PlankDockContainer* base,
                                               PlankDockElement* element)
{
	PlankDockController * self;
	PlankDockItemProvider* provider = NULL;
	PlankDockItemProvider* _tmp0_;
	PlankDockItemProvider* _tmp1_;
	guint _tmp2_;
	PlankDockItemProvider* _tmp3_;
	guint _tmp4_;
	PlankDockItemProvider* _tmp5_;
	guint _tmp6_;
	PlankApplicationDockItemProvider* app_provider = NULL;
	PlankDockItemProvider* _tmp7_;
	PlankApplicationDockItemProvider* _tmp8_;
#line 231 "../lib/DockController.vala"
	self = (PlankDockController*) base;
#line 231 "../lib/DockController.vala"
	g_return_if_fail (element != NULL);
#line 233 "../lib/DockController.vala"
	provider = PLANK_IS_DOCK_ITEM_PROVIDER (element) ? ((PlankDockItemProvider*) element) : NULL;
#line 234 "../lib/DockController.vala"
	_tmp0_ = provider;
#line 234 "../lib/DockController.vala"
	if (_tmp0_ == NULL) {
#line 235 "../lib/DockController.vala"
		return;
#line 799 "DockController.c"
	}
#line 237 "../lib/DockController.vala"
	_tmp1_ = provider;
#line 237 "../lib/DockController.vala"
	g_signal_parse_name ("positions-changed", PLANK_TYPE_DOCK_CONTAINER, &_tmp2_, NULL, FALSE);
#line 237 "../lib/DockController.vala"
	g_signal_handlers_disconnect_matched ((PlankDockContainer*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_dock_controller_handle_positions_changed_plank_dock_container_positions_changed, self);
#line 238 "../lib/DockController.vala"
	_tmp3_ = provider;
#line 238 "../lib/DockController.vala"
	g_signal_parse_name ("states-changed", PLANK_TYPE_DOCK_CONTAINER, &_tmp4_, NULL, FALSE);
#line 238 "../lib/DockController.vala"
	g_signal_handlers_disconnect_matched ((PlankDockContainer*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _plank_dock_controller_handle_states_changed_plank_dock_container_states_changed, self);
#line 239 "../lib/DockController.vala"
	_tmp5_ = provider;
#line 239 "../lib/DockController.vala"
	g_signal_parse_name ("elements-changed", PLANK_TYPE_DOCK_CONTAINER, &_tmp6_, NULL, FALSE);
#line 239 "../lib/DockController.vala"
	g_signal_handlers_disconnect_matched ((PlankDockContainer*) _tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _plank_dock_controller_handle_elements_changed_plank_dock_container_elements_changed, self);
#line 241 "../lib/DockController.vala"
	_tmp7_ = provider;
#line 241 "../lib/DockController.vala"
	app_provider = PLANK_IS_APPLICATION_DOCK_ITEM_PROVIDER (_tmp7_) ? ((PlankApplicationDockItemProvider*) _tmp7_) : NULL;
#line 242 "../lib/DockController.vala"
	_tmp8_ = app_provider;
#line 242 "../lib/DockController.vala"
	if (_tmp8_ != NULL) {
#line 827 "DockController.c"
		PlankApplicationDockItemProvider* _tmp9_;
		PlankDockWindow* _tmp10_;
		guint _tmp11_;
		PlankUnity* _tmp12_;
		PlankApplicationDockItemProvider* _tmp13_;
#line 243 "../lib/DockController.vala"
		_tmp9_ = app_provider;
#line 243 "../lib/DockController.vala"
		_tmp10_ = self->priv->_window;
#line 243 "../lib/DockController.vala"
		g_signal_parse_name ("item-window-added", PLANK_TYPE_APPLICATION_DOCK_ITEM_PROVIDER, &_tmp11_, NULL, FALSE);
#line 243 "../lib/DockController.vala"
		g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _plank_dock_window_update_icon_region_plank_application_dock_item_provider_item_window_added, _tmp10_);
#line 244 "../lib/DockController.vala"
		_tmp12_ = plank_unity_get_default ();
#line 244 "../lib/DockController.vala"
		_tmp13_ = app_provider;
#line 244 "../lib/DockController.vala"
		plank_unity_remove_client (_tmp12_, (PlankUnityClient*) _tmp13_);
#line 847 "DockController.c"
	}
}

static void
plank_dock_controller_real_update_visible_elements (PlankDockContainer* base)
{
	PlankDockController * self;
	GeeArrayList* _tmp0_;
	gint current_position = 0;
#line 248 "../lib/DockController.vala"
	self = (PlankDockController*) base;
#line 250 "../lib/DockController.vala"
	PLANK_DOCK_CONTAINER_CLASS (plank_dock_controller_parent_class)->update_visible_elements (G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_DOCK_CONTAINER, PlankDockContainer));
#line 252 "../lib/DockController.vala"
	plank_logger_verbose ("DockController.update_visible_items ()", NULL);
#line 254 "../lib/DockController.vala"
	_tmp0_ = self->priv->visible_items;
#line 254 "../lib/DockController.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 256 "../lib/DockController.vala"
	current_position = 0;
#line 257 "../lib/DockController.vala"
	plank_dock_controller_update_visible_items_recursive (self, (PlankDockContainer*) self, &current_position);
#line 871 "DockController.c"
}

static void
plank_dock_controller_update_visible_items_recursive (PlankDockController* self,
                                                      PlankDockContainer* container,
                                                      gint* current_position)
{
	GeeBidirListIterator* iterator = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeBidirListIterator* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 260 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 260 "../lib/DockController.vala"
	g_return_if_fail (container != NULL);
#line 262 "../lib/DockController.vala"
	_tmp0_ = plank_dock_container_get_VisibleElements (container);
#line 262 "../lib/DockController.vala"
	_tmp1_ = _tmp0_;
#line 262 "../lib/DockController.vala"
	_tmp2_ = gee_abstract_bidir_list_bidir_list_iterator ((GeeAbstractBidirList*) _tmp1_);
#line 262 "../lib/DockController.vala"
	iterator = _tmp2_;
#line 265 "../lib/DockController.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 898 "DockController.c"
		PlankDockPreferences* _tmp4_;
#line 265 "../lib/DockController.vala"
		_tmp4_ = self->priv->_prefs;
#line 265 "../lib/DockController.vala"
		_tmp3_ = plank_dock_preferences_is_horizontal_dock (_tmp4_);
#line 904 "DockController.c"
	} else {
#line 265 "../lib/DockController.vala"
		_tmp3_ = FALSE;
#line 908 "DockController.c"
	}
#line 265 "../lib/DockController.vala"
	if (_tmp3_) {
#line 912 "DockController.c"
		GeeBidirListIterator* _tmp5_;
#line 266 "../lib/DockController.vala"
		_tmp5_ = iterator;
#line 266 "../lib/DockController.vala"
		gee_bidir_iterator_last ((GeeBidirIterator*) _tmp5_);
#line 918 "DockController.c"
		{
			gboolean _tmp6_ = FALSE;
#line 267 "../lib/DockController.vala"
			_tmp6_ = TRUE;
#line 267 "../lib/DockController.vala"
			while (TRUE) {
#line 925 "DockController.c"
				GeeBidirListIterator* _tmp8_;
#line 267 "../lib/DockController.vala"
				if (!_tmp6_) {
#line 929 "DockController.c"
					GeeBidirListIterator* _tmp7_;
#line 269 "../lib/DockController.vala"
					_tmp7_ = iterator;
#line 269 "../lib/DockController.vala"
					if (!gee_bidir_iterator_previous ((GeeBidirIterator*) _tmp7_)) {
#line 269 "../lib/DockController.vala"
						break;
#line 937 "DockController.c"
					}
				}
#line 267 "../lib/DockController.vala"
				_tmp6_ = FALSE;
#line 268 "../lib/DockController.vala"
				_tmp8_ = iterator;
#line 268 "../lib/DockController.vala"
				plank_dock_controller_update_visible_items_add_from_iterator (self, (GeeIterator*) _tmp8_, current_position);
#line 946 "DockController.c"
			}
		}
	} else {
		GeeBidirListIterator* _tmp9_;
#line 271 "../lib/DockController.vala"
		_tmp9_ = iterator;
#line 271 "../lib/DockController.vala"
		gee_bidir_iterator_first ((GeeBidirIterator*) _tmp9_);
#line 955 "DockController.c"
		{
			gboolean _tmp10_ = FALSE;
#line 272 "../lib/DockController.vala"
			_tmp10_ = TRUE;
#line 272 "../lib/DockController.vala"
			while (TRUE) {
#line 962 "DockController.c"
				GeeBidirListIterator* _tmp12_;
#line 272 "../lib/DockController.vala"
				if (!_tmp10_) {
#line 966 "DockController.c"
					GeeBidirListIterator* _tmp11_;
#line 274 "../lib/DockController.vala"
					_tmp11_ = iterator;
#line 274 "../lib/DockController.vala"
					if (!gee_iterator_next ((GeeIterator*) _tmp11_)) {
#line 274 "../lib/DockController.vala"
						break;
#line 974 "DockController.c"
					}
				}
#line 272 "../lib/DockController.vala"
				_tmp10_ = FALSE;
#line 273 "../lib/DockController.vala"
				_tmp12_ = iterator;
#line 273 "../lib/DockController.vala"
				plank_dock_controller_update_visible_items_add_from_iterator (self, (GeeIterator*) _tmp12_, current_position);
#line 983 "DockController.c"
			}
		}
	}
#line 260 "../lib/DockController.vala"
	_g_object_unref0 (iterator);
#line 989 "DockController.c"
}

static inline void
plank_dock_controller_update_visible_items_add_from_iterator (PlankDockController* self,
                                                              GeeIterator* iterator,
                                                              gint* current_position)
{
	PlankDockElement* element = NULL;
	gpointer _tmp0_;
	PlankDockItem* item = NULL;
	PlankDockContainer* container = NULL;
	PlankDockElement* _tmp1_;
	PlankDockContainer* _tmp2_;
	PlankDockElement* _tmp4_;
	PlankDockItem* _tmp5_;
	PlankDockItem* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp10_;
	GeeArrayList* _tmp11_;
	PlankDockItem* _tmp12_;
#line 278 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 278 "../lib/DockController.vala"
	g_return_if_fail (iterator != NULL);
#line 280 "../lib/DockController.vala"
	_tmp0_ = gee_iterator_get (iterator);
#line 280 "../lib/DockController.vala"
	element = (PlankDockElement*) _tmp0_;
#line 281 "../lib/DockController.vala"
	item = NULL;
#line 282 "../lib/DockController.vala"
	container = NULL;
#line 284 "../lib/DockController.vala"
	_tmp1_ = element;
#line 284 "../lib/DockController.vala"
	container = PLANK_IS_DOCK_CONTAINER (_tmp1_) ? ((PlankDockContainer*) _tmp1_) : NULL;
#line 285 "../lib/DockController.vala"
	_tmp2_ = container;
#line 285 "../lib/DockController.vala"
	if (_tmp2_ != NULL) {
#line 1031 "DockController.c"
		PlankDockContainer* _tmp3_;
#line 286 "../lib/DockController.vala"
		_tmp3_ = container;
#line 286 "../lib/DockController.vala"
		plank_dock_controller_update_visible_items_recursive (self, _tmp3_, current_position);
#line 287 "../lib/DockController.vala"
		_g_object_unref0 (element);
#line 287 "../lib/DockController.vala"
		return;
#line 1041 "DockController.c"
	}
#line 290 "../lib/DockController.vala"
	_tmp4_ = element;
#line 290 "../lib/DockController.vala"
	item = PLANK_IS_DOCK_ITEM (_tmp4_) ? ((PlankDockItem*) _tmp4_) : NULL;
#line 291 "../lib/DockController.vala"
	_tmp5_ = item;
#line 291 "../lib/DockController.vala"
	if (_tmp5_ == NULL) {
#line 292 "../lib/DockController.vala"
		_g_object_unref0 (element);
#line 292 "../lib/DockController.vala"
		return;
#line 1055 "DockController.c"
	}
#line 294 "../lib/DockController.vala"
	_tmp6_ = item;
#line 294 "../lib/DockController.vala"
	_tmp7_ = plank_dock_item_get_Position (_tmp6_);
#line 294 "../lib/DockController.vala"
	_tmp8_ = _tmp7_;
#line 294 "../lib/DockController.vala"
	if (_tmp8_ != (*current_position)) {
#line 1065 "DockController.c"
		PlankDockItem* _tmp9_;
#line 295 "../lib/DockController.vala"
		_tmp9_ = item;
#line 295 "../lib/DockController.vala"
		plank_dock_item_set_Position (_tmp9_, *current_position);
#line 1071 "DockController.c"
	}
#line 296 "../lib/DockController.vala"
	_tmp10_ = *current_position;
#line 296 "../lib/DockController.vala"
	*current_position = _tmp10_ + 1;
#line 298 "../lib/DockController.vala"
	_tmp11_ = self->priv->visible_items;
#line 298 "../lib/DockController.vala"
	_tmp12_ = item;
#line 298 "../lib/DockController.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 278 "../lib/DockController.vala"
	_g_object_unref0 (element);
#line 1085 "DockController.c"
}

static void
plank_dock_controller_update_items (PlankDockController* self)
{
	GeeArrayList* _tmp0_;
	PlankDockItem* item = NULL;
	PlankDockContainer* container = NULL;
#line 301 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 303 "../lib/DockController.vala"
	plank_logger_verbose ("DockController.update_items ()", NULL);
#line 305 "../lib/DockController.vala"
	_tmp0_ = self->priv->items;
#line 305 "../lib/DockController.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 307 "../lib/DockController.vala"
	item = NULL;
#line 308 "../lib/DockController.vala"
	container = NULL;
#line 1106 "DockController.c"
	{
		GeeArrayList* _element_list = NULL;
		GeeArrayList* _tmp1_;
		gint _element_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _element_index = 0;
#line 310 "../lib/DockController.vala"
		_tmp1_ = ((PlankDockContainer*) self)->internal_elements;
#line 310 "../lib/DockController.vala"
		_element_list = _tmp1_;
#line 310 "../lib/DockController.vala"
		_tmp2_ = _element_list;
#line 310 "../lib/DockController.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 310 "../lib/DockController.vala"
		_tmp4_ = _tmp3_;
#line 310 "../lib/DockController.vala"
		_element_size = _tmp4_;
#line 310 "../lib/DockController.vala"
		_element_index = -1;
#line 310 "../lib/DockController.vala"
		while (TRUE) {
#line 1131 "DockController.c"
			gint _tmp5_;
			gint _tmp6_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			PlankDockElement* _tmp9_;
			PlankDockItem* _tmp10_;
			PlankDockElement* _tmp13_;
			PlankDockContainer* _tmp14_;
#line 310 "../lib/DockController.vala"
			_element_index = _element_index + 1;
#line 310 "../lib/DockController.vala"
			_tmp5_ = _element_index;
#line 310 "../lib/DockController.vala"
			_tmp6_ = _element_size;
#line 310 "../lib/DockController.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 310 "../lib/DockController.vala"
				break;
#line 1151 "DockController.c"
			}
#line 310 "../lib/DockController.vala"
			_tmp7_ = _element_list;
#line 310 "../lib/DockController.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _element_index);
#line 310 "../lib/DockController.vala"
			element = (PlankDockElement*) _tmp8_;
#line 311 "../lib/DockController.vala"
			_tmp9_ = element;
#line 311 "../lib/DockController.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp9_) ? ((PlankDockItem*) _tmp9_) : NULL;
#line 312 "../lib/DockController.vala"
			_tmp10_ = item;
#line 312 "../lib/DockController.vala"
			if (_tmp10_ != NULL) {
#line 1167 "DockController.c"
				GeeArrayList* _tmp11_;
				PlankDockItem* _tmp12_;
#line 313 "../lib/DockController.vala"
				_tmp11_ = self->priv->items;
#line 313 "../lib/DockController.vala"
				_tmp12_ = item;
#line 313 "../lib/DockController.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 314 "../lib/DockController.vala"
				_g_object_unref0 (element);
#line 314 "../lib/DockController.vala"
				continue;
#line 1180 "DockController.c"
			}
#line 317 "../lib/DockController.vala"
			_tmp13_ = element;
#line 317 "../lib/DockController.vala"
			container = PLANK_IS_DOCK_CONTAINER (_tmp13_) ? ((PlankDockContainer*) _tmp13_) : NULL;
#line 318 "../lib/DockController.vala"
			_tmp14_ = container;
#line 318 "../lib/DockController.vala"
			if (_tmp14_ == NULL) {
#line 319 "../lib/DockController.vala"
				_g_object_unref0 (element);
#line 319 "../lib/DockController.vala"
				continue;
#line 1194 "DockController.c"
			}
			{
				GeeArrayList* _element2_list = NULL;
				PlankDockContainer* _tmp15_;
				GeeArrayList* _tmp16_;
				GeeArrayList* _tmp17_;
				gint _element2_size = 0;
				GeeArrayList* _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gint _element2_index = 0;
#line 321 "../lib/DockController.vala"
				_tmp15_ = container;
#line 321 "../lib/DockController.vala"
				_tmp16_ = plank_dock_container_get_Elements (_tmp15_);
#line 321 "../lib/DockController.vala"
				_tmp17_ = _tmp16_;
#line 321 "../lib/DockController.vala"
				_element2_list = _tmp17_;
#line 321 "../lib/DockController.vala"
				_tmp18_ = _element2_list;
#line 321 "../lib/DockController.vala"
				_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 321 "../lib/DockController.vala"
				_tmp20_ = _tmp19_;
#line 321 "../lib/DockController.vala"
				_element2_size = _tmp20_;
#line 321 "../lib/DockController.vala"
				_element2_index = -1;
#line 321 "../lib/DockController.vala"
				while (TRUE) {
#line 1226 "DockController.c"
					gint _tmp21_;
					gint _tmp22_;
					PlankDockElement* element2 = NULL;
					GeeArrayList* _tmp23_;
					gpointer _tmp24_;
					PlankDockElement* _tmp25_;
					PlankDockItem* _tmp26_;
					GeeArrayList* _tmp27_;
					PlankDockItem* _tmp28_;
#line 321 "../lib/DockController.vala"
					_element2_index = _element2_index + 1;
#line 321 "../lib/DockController.vala"
					_tmp21_ = _element2_index;
#line 321 "../lib/DockController.vala"
					_tmp22_ = _element2_size;
#line 321 "../lib/DockController.vala"
					if (!(_tmp21_ < _tmp22_)) {
#line 321 "../lib/DockController.vala"
						break;
#line 1246 "DockController.c"
					}
#line 321 "../lib/DockController.vala"
					_tmp23_ = _element2_list;
#line 321 "../lib/DockController.vala"
					_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp23_, _element2_index);
#line 321 "../lib/DockController.vala"
					element2 = (PlankDockElement*) _tmp24_;
#line 322 "../lib/DockController.vala"
					_tmp25_ = element2;
#line 322 "../lib/DockController.vala"
					item = PLANK_IS_DOCK_ITEM (_tmp25_) ? ((PlankDockItem*) _tmp25_) : NULL;
#line 323 "../lib/DockController.vala"
					_tmp26_ = item;
#line 323 "../lib/DockController.vala"
					if (_tmp26_ == NULL) {
#line 324 "../lib/DockController.vala"
						_g_object_unref0 (element2);
#line 324 "../lib/DockController.vala"
						continue;
#line 1266 "DockController.c"
					}
#line 325 "../lib/DockController.vala"
					_tmp27_ = self->priv->items;
#line 325 "../lib/DockController.vala"
					_tmp28_ = item;
#line 325 "../lib/DockController.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
#line 321 "../lib/DockController.vala"
					_g_object_unref0 (element2);
#line 1276 "DockController.c"
				}
			}
#line 310 "../lib/DockController.vala"
			_g_object_unref0 (element);
#line 1281 "DockController.c"
		}
	}
}

static void
plank_dock_controller_handle_elements_changed (PlankDockController* self,
                                               PlankDockContainer* container,
                                               GeeList* added,
                                               GeeList* removed)
{
	PlankDockRenderer* _tmp0_;
	PlankDockRenderer* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	PlankDockWindow* _tmp10_;
#line 330 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 330 "../lib/DockController.vala"
	g_return_if_fail (container != NULL);
#line 330 "../lib/DockController.vala"
	g_return_if_fail (added != NULL);
#line 330 "../lib/DockController.vala"
	g_return_if_fail (removed != NULL);
#line 333 "../lib/DockController.vala"
	_tmp0_ = self->priv->_renderer;
#line 333 "../lib/DockController.vala"
	plank_dock_renderer_animate_items (_tmp0_, added);
#line 334 "../lib/DockController.vala"
	_tmp1_ = self->priv->_renderer;
#line 334 "../lib/DockController.vala"
	plank_dock_renderer_animate_items (_tmp1_, removed);
#line 336 "../lib/DockController.vala"
	plank_dock_container_update_visible_elements ((PlankDockContainer*) self);
#line 337 "../lib/DockController.vala"
	plank_dock_controller_update_items (self);
#line 339 "../lib/DockController.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) added);
#line 339 "../lib/DockController.vala"
	_tmp3_ = _tmp2_;
#line 339 "../lib/DockController.vala"
	_tmp4_ = gee_collection_get_size ((GeeCollection*) removed);
#line 339 "../lib/DockController.vala"
	_tmp5_ = _tmp4_;
#line 339 "../lib/DockController.vala"
	if (_tmp3_ != _tmp5_) {
#line 1329 "DockController.c"
		PlankPositionManager* _tmp6_;
		PlankDockRenderer* _tmp7_;
		PlankDockTheme* _tmp8_;
		PlankDockTheme* _tmp9_;
#line 340 "../lib/DockController.vala"
		_tmp6_ = self->priv->_position_manager;
#line 340 "../lib/DockController.vala"
		_tmp7_ = self->priv->_renderer;
#line 340 "../lib/DockController.vala"
		_tmp8_ = plank_dock_renderer_get_theme (_tmp7_);
#line 340 "../lib/DockController.vala"
		_tmp9_ = _tmp8_;
#line 340 "../lib/DockController.vala"
		plank_position_manager_update (_tmp6_, _tmp9_);
#line 1344 "DockController.c"
	}
#line 342 "../lib/DockController.vala"
	_tmp10_ = self->priv->_window;
#line 342 "../lib/DockController.vala"
	plank_dock_window_update_icon_regions (_tmp10_);
#line 344 "../lib/DockController.vala"
	plank_dock_controller_schedule_serialize_item_positions (self);
#line 347 "../lib/DockController.vala"
	if (container != G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_DOCK_CONTAINER, PlankDockContainer)) {
#line 1354 "DockController.c"
		GeeArrayList* empty = NULL;
		GeeArrayList* _tmp11_;
		GeeArrayList* _tmp12_;
		GeeArrayList* _tmp13_;
#line 348 "../lib/DockController.vala"
		_tmp11_ = gee_array_list_new (PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 348 "../lib/DockController.vala"
		empty = _tmp11_;
#line 349 "../lib/DockController.vala"
		_tmp12_ = empty;
#line 349 "../lib/DockController.vala"
		_tmp13_ = empty;
#line 349 "../lib/DockController.vala"
		g_signal_emit_by_name ((PlankDockContainer*) self, "elements-changed", (GeeList*) _tmp12_, (GeeList*) _tmp13_);
#line 347 "../lib/DockController.vala"
		_g_object_unref0 (empty);
#line 1371 "DockController.c"
	}
}

static void
plank_dock_controller_handle_positions_changed (PlankDockController* self,
                                                PlankDockContainer* container,
                                                GeeList* moved_items)
{
	PlankDockRenderer* _tmp11_;
#line 353 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 353 "../lib/DockController.vala"
	g_return_if_fail (container != NULL);
#line 353 "../lib/DockController.vala"
	g_return_if_fail (moved_items != NULL);
#line 355 "../lib/DockController.vala"
	plank_dock_container_update_visible_elements ((PlankDockContainer*) self);
#line 1389 "DockController.c"
	{
		GeeList* _item_list = NULL;
		gint _item_size = 0;
		GeeList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _item_index = 0;
#line 357 "../lib/DockController.vala"
		_item_list = moved_items;
#line 357 "../lib/DockController.vala"
		_tmp0_ = _item_list;
#line 357 "../lib/DockController.vala"
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 357 "../lib/DockController.vala"
		_tmp2_ = _tmp1_;
#line 357 "../lib/DockController.vala"
		_item_size = _tmp2_;
#line 357 "../lib/DockController.vala"
		_item_index = -1;
#line 357 "../lib/DockController.vala"
		while (TRUE) {
#line 1411 "DockController.c"
			gint _tmp3_;
			gint _tmp4_;
			PlankDockElement* item = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			PlankApplicationDockItem* app_item = NULL;
			PlankDockElement* _tmp7_;
			PlankApplicationDockItem* _tmp8_;
#line 357 "../lib/DockController.vala"
			_item_index = _item_index + 1;
#line 357 "../lib/DockController.vala"
			_tmp3_ = _item_index;
#line 357 "../lib/DockController.vala"
			_tmp4_ = _item_size;
#line 357 "../lib/DockController.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 357 "../lib/DockController.vala"
				break;
#line 1430 "DockController.c"
			}
#line 357 "../lib/DockController.vala"
			_tmp5_ = _item_list;
#line 357 "../lib/DockController.vala"
			_tmp6_ = gee_list_get (_tmp5_, _item_index);
#line 357 "../lib/DockController.vala"
			item = (PlankDockElement*) _tmp6_;
#line 358 "../lib/DockController.vala"
			_tmp7_ = item;
#line 358 "../lib/DockController.vala"
			app_item = PLANK_IS_APPLICATION_DOCK_ITEM (_tmp7_) ? ((PlankApplicationDockItem*) _tmp7_) : NULL;
#line 359 "../lib/DockController.vala"
			_tmp8_ = app_item;
#line 359 "../lib/DockController.vala"
			if (_tmp8_ != NULL) {
#line 1446 "DockController.c"
				PlankDockWindow* _tmp9_;
				PlankApplicationDockItem* _tmp10_;
#line 360 "../lib/DockController.vala"
				_tmp9_ = self->priv->_window;
#line 360 "../lib/DockController.vala"
				_tmp10_ = app_item;
#line 360 "../lib/DockController.vala"
				plank_dock_window_update_icon_region (_tmp9_, _tmp10_);
#line 1455 "DockController.c"
			}
		}
	}
#line 362 "../lib/DockController.vala"
	_tmp11_ = self->priv->_renderer;
#line 362 "../lib/DockController.vala"
	plank_renderer_animated_draw ((PlankRenderer*) _tmp11_);
#line 364 "../lib/DockController.vala"
	plank_dock_controller_schedule_serialize_item_positions (self);
#line 1465 "DockController.c"
}

static void
plank_dock_controller_handle_states_changed (PlankDockController* self,
                                             PlankDockContainer* container)
{
	PlankDockRenderer* _tmp0_;
#line 367 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 367 "../lib/DockController.vala"
	g_return_if_fail (container != NULL);
#line 369 "../lib/DockController.vala"
	_tmp0_ = self->priv->_renderer;
#line 369 "../lib/DockController.vala"
	plank_renderer_animated_draw ((PlankRenderer*) _tmp0_);
#line 1481 "DockController.c"
}

static void
plank_dock_controller_schedule_serialize_item_positions (PlankDockController* self)
{
#line 372 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 374 "../lib/DockController.vala"
	if (self->priv->serialize_item_positions_timer_id > 0U) {
#line 375 "../lib/DockController.vala"
		return;
#line 1493 "DockController.c"
	}
#line 377 "../lib/DockController.vala"
	self->priv->serialize_item_positions_timer_id = gdk_threads_add_timeout (PLANK_ITEM_SERIALIZATION_DELAY, (GSourceFunc) plank_dock_controller_serialize_item_positions, self);
#line 1497 "DockController.c"
}

static gboolean
plank_dock_controller_serialize_item_positions (PlankDockController* self)
{
	GeeArrayList* item_list = NULL;
	GeeArrayList* _tmp0_;
	PlankDockPreferences* _tmp24_;
	GeeArrayList* _tmp25_;
	gint _tmp26_ = 0;
	gpointer* _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	gboolean result;
#line 380 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 382 "../lib/DockController.vala"
	self->priv->serialize_item_positions_timer_id = 0U;
#line 384 "../lib/DockController.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 384 "../lib/DockController.vala"
	item_list = _tmp0_;
#line 1520 "DockController.c"
	{
		GeeArrayList* _element_list = NULL;
		GeeArrayList* _tmp1_;
		gint _element_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _element_index = 0;
#line 386 "../lib/DockController.vala"
		_tmp1_ = ((PlankDockContainer*) self)->internal_elements;
#line 386 "../lib/DockController.vala"
		_element_list = _tmp1_;
#line 386 "../lib/DockController.vala"
		_tmp2_ = _element_list;
#line 386 "../lib/DockController.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 386 "../lib/DockController.vala"
		_tmp4_ = _tmp3_;
#line 386 "../lib/DockController.vala"
		_element_size = _tmp4_;
#line 386 "../lib/DockController.vala"
		_element_index = -1;
#line 386 "../lib/DockController.vala"
		while (TRUE) {
#line 1545 "DockController.c"
			gint _tmp5_;
			gint _tmp6_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			PlankDockItem* item = NULL;
			PlankDockElement* _tmp9_;
			PlankDockItem* _tmp10_;
			PlankDockItemProvider* provider = NULL;
			PlankDockElement* _tmp16_;
			PlankDockItemProvider* _tmp17_;
#line 386 "../lib/DockController.vala"
			_element_index = _element_index + 1;
#line 386 "../lib/DockController.vala"
			_tmp5_ = _element_index;
#line 386 "../lib/DockController.vala"
			_tmp6_ = _element_size;
#line 386 "../lib/DockController.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 386 "../lib/DockController.vala"
				break;
#line 1567 "DockController.c"
			}
#line 386 "../lib/DockController.vala"
			_tmp7_ = _element_list;
#line 386 "../lib/DockController.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _element_index);
#line 386 "../lib/DockController.vala"
			element = (PlankDockElement*) _tmp8_;
#line 387 "../lib/DockController.vala"
			_tmp9_ = element;
#line 387 "../lib/DockController.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp9_) ? ((PlankDockItem*) _tmp9_) : NULL;
#line 388 "../lib/DockController.vala"
			_tmp10_ = item;
#line 388 "../lib/DockController.vala"
			if (_tmp10_ != NULL) {
#line 1583 "DockController.c"
				GeeArrayList* _tmp11_;
				PlankDockItem* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 389 "../lib/DockController.vala"
				_tmp11_ = item_list;
#line 389 "../lib/DockController.vala"
				_tmp12_ = item;
#line 389 "../lib/DockController.vala"
				_tmp13_ = plank_dock_item_get_DockItemFilename (_tmp12_);
#line 389 "../lib/DockController.vala"
				_tmp14_ = _tmp13_;
#line 389 "../lib/DockController.vala"
				_tmp15_ = _tmp14_;
#line 389 "../lib/DockController.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp15_);
#line 389 "../lib/DockController.vala"
				_g_free0 (_tmp15_);
#line 390 "../lib/DockController.vala"
				_g_object_unref0 (element);
#line 390 "../lib/DockController.vala"
				continue;
#line 1607 "DockController.c"
			}
#line 392 "../lib/DockController.vala"
			_tmp16_ = element;
#line 392 "../lib/DockController.vala"
			provider = PLANK_IS_DOCK_ITEM_PROVIDER (_tmp16_) ? ((PlankDockItemProvider*) _tmp16_) : NULL;
#line 393 "../lib/DockController.vala"
			_tmp17_ = provider;
#line 393 "../lib/DockController.vala"
			if (_tmp17_ != NULL) {
#line 1617 "DockController.c"
				gchar** list = NULL;
				PlankDockItemProvider* _tmp18_;
				gint _tmp19_ = 0;
				gchar** _tmp20_;
				gint list_length1;
				gint _list_size_;
				gchar** _tmp21_;
				gint _tmp21__length1;
#line 394 "../lib/DockController.vala"
				_tmp18_ = provider;
#line 394 "../lib/DockController.vala"
				_tmp20_ = plank_dock_item_provider_get_dockitem_filenames (_tmp18_, &_tmp19_);
#line 394 "../lib/DockController.vala"
				list = _tmp20_;
#line 394 "../lib/DockController.vala"
				list_length1 = _tmp19_;
#line 394 "../lib/DockController.vala"
				_list_size_ = list_length1;
#line 395 "../lib/DockController.vala"
				_tmp21_ = list;
#line 395 "../lib/DockController.vala"
				_tmp21__length1 = list_length1;
#line 1640 "DockController.c"
				{
					gchar** s_collection = NULL;
					gint s_collection_length1 = 0;
					gint _s_collection_size_ = 0;
					gint s_it = 0;
#line 395 "../lib/DockController.vala"
					s_collection = _tmp21_;
#line 395 "../lib/DockController.vala"
					s_collection_length1 = _tmp21__length1;
#line 395 "../lib/DockController.vala"
					for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
#line 1652 "DockController.c"
						const gchar* s = NULL;
#line 395 "../lib/DockController.vala"
						s = s_collection[s_it];
#line 1656 "DockController.c"
						{
							GeeArrayList* _tmp22_;
							const gchar* _tmp23_;
#line 396 "../lib/DockController.vala"
							_tmp22_ = item_list;
#line 396 "../lib/DockController.vala"
							_tmp23_ = s;
#line 396 "../lib/DockController.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, _tmp23_);
#line 1666 "DockController.c"
						}
					}
				}
#line 397 "../lib/DockController.vala"
				list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 397 "../lib/DockController.vala"
				_g_object_unref0 (element);
#line 397 "../lib/DockController.vala"
				continue;
#line 1676 "DockController.c"
			}
#line 386 "../lib/DockController.vala"
			_g_object_unref0 (element);
#line 1680 "DockController.c"
		}
	}
#line 401 "../lib/DockController.vala"
	_tmp24_ = self->priv->_prefs;
#line 401 "../lib/DockController.vala"
	_tmp25_ = item_list;
#line 401 "../lib/DockController.vala"
	_tmp27_ = gee_collection_to_array ((GeeCollection*) _tmp25_, &_tmp26_);
#line 401 "../lib/DockController.vala"
	_tmp28_ = _tmp27_;
#line 401 "../lib/DockController.vala"
	_tmp28__length1 = _tmp26_;
#line 401 "../lib/DockController.vala"
	plank_dock_preferences_set_DockItems (_tmp24_, _tmp28_, _tmp26_);
#line 401 "../lib/DockController.vala"
	_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 403 "../lib/DockController.vala"
	result = FALSE;
#line 403 "../lib/DockController.vala"
	_g_object_unref0 (item_list);
#line 403 "../lib/DockController.vala"
	return result;
#line 1703 "DockController.c"
}

const gchar*
plank_dock_controller_get_name (PlankDockController* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../lib/DockController.vala"
	_tmp0_ = self->priv->_name;
#line 31 "../lib/DockController.vala"
	result = _tmp0_;
#line 31 "../lib/DockController.vala"
	return result;
#line 1719 "DockController.c"
}

static void
plank_dock_controller_set_name (PlankDockController* self,
                                const gchar* value)
{
	gchar* old_value;
#line 31 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 31 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_name (self);
#line 31 "../lib/DockController.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1733 "DockController.c"
		gchar* _tmp0_;
#line 31 "../lib/DockController.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../lib/DockController.vala"
		_g_free0 (self->priv->_name);
#line 31 "../lib/DockController.vala"
		self->priv->_name = _tmp0_;
#line 31 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_NAME_PROPERTY]);
#line 1743 "DockController.c"
	}
}

GFile*
plank_dock_controller_get_config_folder (PlankDockController* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 32 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../lib/DockController.vala"
	_tmp0_ = self->priv->_config_folder;
#line 32 "../lib/DockController.vala"
	result = _tmp0_;
#line 32 "../lib/DockController.vala"
	return result;
#line 1760 "DockController.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 32 "../lib/DockController.vala"
	return self ? g_object_ref (self) : NULL;
#line 1768 "DockController.c"
}

static void
plank_dock_controller_set_config_folder (PlankDockController* self,
                                         GFile* value)
{
	GFile* old_value;
#line 32 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 32 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_config_folder (self);
#line 32 "../lib/DockController.vala"
	if (old_value != value) {
#line 1782 "DockController.c"
		GFile* _tmp0_;
#line 32 "../lib/DockController.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 32 "../lib/DockController.vala"
		_g_object_unref0 (self->priv->_config_folder);
#line 32 "../lib/DockController.vala"
		self->priv->_config_folder = _tmp0_;
#line 32 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_CONFIG_FOLDER_PROPERTY]);
#line 1792 "DockController.c"
	}
}

GFile*
plank_dock_controller_get_launchers_folder (PlankDockController* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 33 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../lib/DockController.vala"
	_tmp0_ = self->priv->_launchers_folder;
#line 33 "../lib/DockController.vala"
	result = _tmp0_;
#line 33 "../lib/DockController.vala"
	return result;
#line 1809 "DockController.c"
}

static void
plank_dock_controller_set_launchers_folder (PlankDockController* self,
                                            GFile* value)
{
	GFile* old_value;
#line 33 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 33 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_launchers_folder (self);
#line 33 "../lib/DockController.vala"
	if (old_value != value) {
#line 1823 "DockController.c"
		GFile* _tmp0_;
#line 33 "../lib/DockController.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 33 "../lib/DockController.vala"
		_g_object_unref0 (self->priv->_launchers_folder);
#line 33 "../lib/DockController.vala"
		self->priv->_launchers_folder = _tmp0_;
#line 33 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_LAUNCHERS_FOLDER_PROPERTY]);
#line 1833 "DockController.c"
	}
}

PlankDockPreferences*
plank_dock_controller_get_prefs (PlankDockController* self)
{
	PlankDockPreferences* result;
	PlankDockPreferences* _tmp0_;
#line 35 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../lib/DockController.vala"
	_tmp0_ = self->priv->_prefs;
#line 35 "../lib/DockController.vala"
	result = _tmp0_;
#line 35 "../lib/DockController.vala"
	return result;
#line 1850 "DockController.c"
}

static void
plank_dock_controller_set_prefs (PlankDockController* self,
                                 PlankDockPreferences* value)
{
	PlankDockPreferences* old_value;
#line 35 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 35 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_prefs (self);
#line 35 "../lib/DockController.vala"
	if (old_value != value) {
#line 1864 "DockController.c"
		PlankDockPreferences* _tmp0_;
#line 35 "../lib/DockController.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "../lib/DockController.vala"
		_g_object_unref0 (self->priv->_prefs);
#line 35 "../lib/DockController.vala"
		self->priv->_prefs = _tmp0_;
#line 35 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_PREFS_PROPERTY]);
#line 1874 "DockController.c"
	}
}

PlankDragManager*
plank_dock_controller_get_drag_manager (PlankDockController* self)
{
	PlankDragManager* result;
	PlankDragManager* _tmp0_;
#line 37 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../lib/DockController.vala"
	_tmp0_ = self->priv->_drag_manager;
#line 37 "../lib/DockController.vala"
	result = _tmp0_;
#line 37 "../lib/DockController.vala"
	return result;
#line 1891 "DockController.c"
}

void
plank_dock_controller_set_drag_manager (PlankDockController* self,
                                        PlankDragManager* value)
{
	PlankDragManager* old_value;
#line 37 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 37 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_drag_manager (self);
#line 37 "../lib/DockController.vala"
	if (old_value != value) {
#line 1905 "DockController.c"
		PlankDragManager* _tmp0_;
#line 37 "../lib/DockController.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../lib/DockController.vala"
		_g_object_unref0 (self->priv->_drag_manager);
#line 37 "../lib/DockController.vala"
		self->priv->_drag_manager = _tmp0_;
#line 37 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_DRAG_MANAGER_PROPERTY]);
#line 1915 "DockController.c"
	}
}

PlankHideManager*
plank_dock_controller_get_hide_manager (PlankDockController* self)
{
	PlankHideManager* result;
	PlankHideManager* _tmp0_;
#line 38 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../lib/DockController.vala"
	_tmp0_ = self->priv->_hide_manager;
#line 38 "../lib/DockController.vala"
	result = _tmp0_;
#line 38 "../lib/DockController.vala"
	return result;
#line 1932 "DockController.c"
}

void
plank_dock_controller_set_hide_manager (PlankDockController* self,
                                        PlankHideManager* value)
{
	PlankHideManager* old_value;
#line 38 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 38 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_hide_manager (self);
#line 38 "../lib/DockController.vala"
	if (old_value != value) {
#line 1946 "DockController.c"
		PlankHideManager* _tmp0_;
#line 38 "../lib/DockController.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../lib/DockController.vala"
		_g_object_unref0 (self->priv->_hide_manager);
#line 38 "../lib/DockController.vala"
		self->priv->_hide_manager = _tmp0_;
#line 38 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_HIDE_MANAGER_PROPERTY]);
#line 1956 "DockController.c"
	}
}

PlankPositionManager*
plank_dock_controller_get_position_manager (PlankDockController* self)
{
	PlankPositionManager* result;
	PlankPositionManager* _tmp0_;
#line 39 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../lib/DockController.vala"
	_tmp0_ = self->priv->_position_manager;
#line 39 "../lib/DockController.vala"
	result = _tmp0_;
#line 39 "../lib/DockController.vala"
	return result;
#line 1973 "DockController.c"
}

void
plank_dock_controller_set_position_manager (PlankDockController* self,
                                            PlankPositionManager* value)
{
	PlankPositionManager* old_value;
#line 39 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 39 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_position_manager (self);
#line 39 "../lib/DockController.vala"
	if (old_value != value) {
#line 1987 "DockController.c"
		PlankPositionManager* _tmp0_;
#line 39 "../lib/DockController.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../lib/DockController.vala"
		_g_object_unref0 (self->priv->_position_manager);
#line 39 "../lib/DockController.vala"
		self->priv->_position_manager = _tmp0_;
#line 39 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_POSITION_MANAGER_PROPERTY]);
#line 1997 "DockController.c"
	}
}

PlankDockRenderer*
plank_dock_controller_get_renderer (PlankDockController* self)
{
	PlankDockRenderer* result;
	PlankDockRenderer* _tmp0_;
#line 40 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../lib/DockController.vala"
	_tmp0_ = self->priv->_renderer;
#line 40 "../lib/DockController.vala"
	result = _tmp0_;
#line 40 "../lib/DockController.vala"
	return result;
#line 2014 "DockController.c"
}

void
plank_dock_controller_set_renderer (PlankDockController* self,
                                    PlankDockRenderer* value)
{
	PlankDockRenderer* old_value;
#line 40 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 40 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_renderer (self);
#line 40 "../lib/DockController.vala"
	if (old_value != value) {
#line 2028 "DockController.c"
		PlankDockRenderer* _tmp0_;
#line 40 "../lib/DockController.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 40 "../lib/DockController.vala"
		_g_object_unref0 (self->priv->_renderer);
#line 40 "../lib/DockController.vala"
		self->priv->_renderer = _tmp0_;
#line 40 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_RENDERER_PROPERTY]);
#line 2038 "DockController.c"
	}
}

PlankDockWindow*
plank_dock_controller_get_window (PlankDockController* self)
{
	PlankDockWindow* result;
	PlankDockWindow* _tmp0_;
#line 41 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../lib/DockController.vala"
	_tmp0_ = self->priv->_window;
#line 41 "../lib/DockController.vala"
	result = _tmp0_;
#line 41 "../lib/DockController.vala"
	return result;
#line 2055 "DockController.c"
}

void
plank_dock_controller_set_window (PlankDockController* self,
                                  PlankDockWindow* value)
{
	PlankDockWindow* old_value;
#line 41 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 41 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_window (self);
#line 41 "../lib/DockController.vala"
	if (old_value != value) {
#line 2069 "DockController.c"
		PlankDockWindow* _tmp0_;
#line 41 "../lib/DockController.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../lib/DockController.vala"
		_g_object_unref0 (self->priv->_window);
#line 41 "../lib/DockController.vala"
		self->priv->_window = _tmp0_;
#line 41 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_WINDOW_PROPERTY]);
#line 2079 "DockController.c"
	}
}

PlankHoverWindow*
plank_dock_controller_get_hover (PlankDockController* self)
{
	PlankHoverWindow* result;
	PlankHoverWindow* _tmp0_;
#line 42 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../lib/DockController.vala"
	_tmp0_ = self->priv->_hover;
#line 42 "../lib/DockController.vala"
	result = _tmp0_;
#line 42 "../lib/DockController.vala"
	return result;
#line 2096 "DockController.c"
}

void
plank_dock_controller_set_hover (PlankDockController* self,
                                 PlankHoverWindow* value)
{
	PlankHoverWindow* old_value;
#line 42 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 42 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_hover (self);
#line 42 "../lib/DockController.vala"
	if (old_value != value) {
#line 2110 "DockController.c"
		PlankHoverWindow* _tmp0_;
#line 42 "../lib/DockController.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 42 "../lib/DockController.vala"
		_g_object_unref0 (self->priv->_hover);
#line 42 "../lib/DockController.vala"
		self->priv->_hover = _tmp0_;
#line 42 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_HOVER_PROPERTY]);
#line 2120 "DockController.c"
	}
}

PlankDockItemProvider*
plank_dock_controller_get_default_provider (PlankDockController* self)
{
	PlankDockItemProvider* result;
	PlankDockItemProvider* _tmp0_;
#line 44 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../lib/DockController.vala"
	_tmp0_ = self->priv->_default_provider;
#line 44 "../lib/DockController.vala"
	result = _tmp0_;
#line 44 "../lib/DockController.vala"
	return result;
#line 2137 "DockController.c"
}

static void
plank_dock_controller_set_default_provider (PlankDockController* self,
                                            PlankDockItemProvider* value)
{
	PlankDockItemProvider* old_value;
#line 44 "../lib/DockController.vala"
	g_return_if_fail (self != NULL);
#line 44 "../lib/DockController.vala"
	old_value = plank_dock_controller_get_default_provider (self);
#line 44 "../lib/DockController.vala"
	if (old_value != value) {
#line 2151 "DockController.c"
		PlankDockItemProvider* _tmp0_;
#line 44 "../lib/DockController.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 44 "../lib/DockController.vala"
		_g_object_unref0 (self->priv->_default_provider);
#line 44 "../lib/DockController.vala"
		self->priv->_default_provider = _tmp0_;
#line 44 "../lib/DockController.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_DEFAULT_PROVIDER_PROPERTY]);
#line 2161 "DockController.c"
	}
}

GeeArrayList*
plank_dock_controller_get_Items (PlankDockController* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 56 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../lib/DockController.vala"
	_tmp0_ = self->priv->items;
#line 57 "../lib/DockController.vala"
	result = _tmp0_;
#line 57 "../lib/DockController.vala"
	return result;
#line 2178 "DockController.c"
}

GeeArrayList*
plank_dock_controller_get_VisibleItems (PlankDockController* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 65 "../lib/DockController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../lib/DockController.vala"
	_tmp0_ = self->priv->visible_items;
#line 66 "../lib/DockController.vala"
	result = _tmp0_;
#line 66 "../lib/DockController.vala"
	return result;
#line 2194 "DockController.c"
}

static GObject *
plank_dock_controller_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankDockController * self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	PlankItemFactory* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	PlankDockPreferences* _tmp8_;
	PlankDockPreferences* _tmp9_;
	PlankDBusManager* _tmp10_;
	PlankPositionManager* _tmp11_;
	PlankPositionManager* _tmp12_;
	PlankDragManager* _tmp13_;
	PlankDragManager* _tmp14_;
	PlankHideManager* _tmp15_;
	PlankHideManager* _tmp16_;
	PlankDockWindow* _tmp17_;
	PlankDockWindow* _tmp18_;
	PlankHoverWindow* _tmp19_;
	PlankHoverWindow* _tmp20_;
	PlankDockWindow* _tmp21_;
	PlankDockRenderer* _tmp22_;
	PlankDockRenderer* _tmp23_;
#line 85 "../lib/DockController.vala"
	parent_class = G_OBJECT_CLASS (plank_dock_controller_parent_class);
#line 85 "../lib/DockController.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 85 "../lib/DockController.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_CONTROLLER, PlankDockController);
#line 87 "../lib/DockController.vala"
	_tmp0_ = self->priv->_config_folder;
#line 87 "../lib/DockController.vala"
	_tmp1_ = g_file_get_child (_tmp0_, "launchers");
#line 87 "../lib/DockController.vala"
	_tmp2_ = _tmp1_;
#line 87 "../lib/DockController.vala"
	plank_dock_controller_set_launchers_folder (self, _tmp2_);
#line 87 "../lib/DockController.vala"
	_g_object_unref0 (_tmp2_);
#line 88 "../lib/DockController.vala"
	_tmp3_ = plank_factory_item_factory;
#line 88 "../lib/DockController.vala"
	_tmp4_ = self->priv->_launchers_folder;
#line 88 "../lib/DockController.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 88 "../lib/DockController.vala"
	_g_object_unref0 (_tmp3_->launchers_dir);
#line 88 "../lib/DockController.vala"
	_tmp3_->launchers_dir = _tmp5_;
#line 90 "../lib/DockController.vala"
	_tmp6_ = gee_array_list_new (PLANK_TYPE_DOCK_ITEM, NULL, NULL, NULL, NULL, NULL);
#line 90 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->items);
#line 90 "../lib/DockController.vala"
	self->priv->items = _tmp6_;
#line 91 "../lib/DockController.vala"
	_tmp7_ = gee_array_list_new (PLANK_TYPE_DOCK_ITEM, NULL, NULL, NULL, NULL, NULL);
#line 91 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->visible_items);
#line 91 "../lib/DockController.vala"
	self->priv->visible_items = _tmp7_;
#line 93 "../lib/DockController.vala"
	_tmp8_ = self->priv->_prefs;
#line 93 "../lib/DockController.vala"
	g_signal_connect_object ((GObject*) _tmp8_, "notify::Position", (GCallback) _plank_dock_container_update_visible_elements_g_object_notify, (PlankDockContainer*) self, 0);
#line 94 "../lib/DockController.vala"
	_tmp9_ = self->priv->_prefs;
#line 94 "../lib/DockController.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::ShowDockItem", (GCallback) _plank_dock_controller_update_show_dock_item_g_object_notify, self, 0);
#line 96 "../lib/DockController.vala"
	_tmp10_ = plank_dbus_manager_new (self);
#line 96 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->dbus_manager);
#line 96 "../lib/DockController.vala"
	self->priv->dbus_manager = _tmp10_;
#line 98 "../lib/DockController.vala"
	_tmp11_ = plank_position_manager_new (self);
#line 98 "../lib/DockController.vala"
	_tmp12_ = _tmp11_;
#line 98 "../lib/DockController.vala"
	plank_dock_controller_set_position_manager (self, _tmp12_);
#line 98 "../lib/DockController.vala"
	_g_object_unref0 (_tmp12_);
#line 99 "../lib/DockController.vala"
	_tmp13_ = plank_drag_manager_new (self);
#line 99 "../lib/DockController.vala"
	_tmp14_ = _tmp13_;
#line 99 "../lib/DockController.vala"
	plank_dock_controller_set_drag_manager (self, _tmp14_);
#line 99 "../lib/DockController.vala"
	_g_object_unref0 (_tmp14_);
#line 100 "../lib/DockController.vala"
	_tmp15_ = plank_hide_manager_new (self);
#line 100 "../lib/DockController.vala"
	_tmp16_ = _tmp15_;
#line 100 "../lib/DockController.vala"
	plank_dock_controller_set_hide_manager (self, _tmp16_);
#line 100 "../lib/DockController.vala"
	_g_object_unref0 (_tmp16_);
#line 101 "../lib/DockController.vala"
	_tmp17_ = plank_dock_window_new (self);
#line 101 "../lib/DockController.vala"
	g_object_ref_sink (_tmp17_);
#line 101 "../lib/DockController.vala"
	_tmp18_ = _tmp17_;
#line 101 "../lib/DockController.vala"
	plank_dock_controller_set_window (self, _tmp18_);
#line 101 "../lib/DockController.vala"
	_g_object_unref0 (_tmp18_);
#line 102 "../lib/DockController.vala"
	_tmp19_ = plank_hover_window_new ();
#line 102 "../lib/DockController.vala"
	g_object_ref_sink (_tmp19_);
#line 102 "../lib/DockController.vala"
	_tmp20_ = _tmp19_;
#line 102 "../lib/DockController.vala"
	plank_dock_controller_set_hover (self, _tmp20_);
#line 102 "../lib/DockController.vala"
	_g_object_unref0 (_tmp20_);
#line 103 "../lib/DockController.vala"
	_tmp21_ = self->priv->_window;
#line 103 "../lib/DockController.vala"
	_tmp22_ = plank_dock_renderer_new (self, (GtkWindow*) _tmp21_);
#line 103 "../lib/DockController.vala"
	_tmp23_ = _tmp22_;
#line 103 "../lib/DockController.vala"
	plank_dock_controller_set_renderer (self, _tmp23_);
#line 103 "../lib/DockController.vala"
	_g_object_unref0 (_tmp23_);
#line 85 "../lib/DockController.vala"
	return obj;
#line 2337 "DockController.c"
}

static void
plank_dock_controller_class_init (PlankDockControllerClass * klass,
                                  gpointer klass_data)
{
#line 29 "../lib/DockController.vala"
	plank_dock_controller_parent_class = g_type_class_peek_parent (klass);
#line 29 "../lib/DockController.vala"
	g_type_class_adjust_private_offset (klass, &PlankDockController_private_offset);
#line 29 "../lib/DockController.vala"
	((PlankDockContainerClass *) klass)->connect_element = (void (*) (PlankDockContainer*, PlankDockElement*)) plank_dock_controller_real_connect_element;
#line 29 "../lib/DockController.vala"
	((PlankDockContainerClass *) klass)->disconnect_element = (void (*) (PlankDockContainer*, PlankDockElement*)) plank_dock_controller_real_disconnect_element;
#line 29 "../lib/DockController.vala"
	((PlankDockContainerClass *) klass)->update_visible_elements = (void (*) (PlankDockContainer*)) plank_dock_controller_real_update_visible_elements;
#line 29 "../lib/DockController.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dock_controller_get_property;
#line 29 "../lib/DockController.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_dock_controller_set_property;
#line 29 "../lib/DockController.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_dock_controller_constructor;
#line 29 "../lib/DockController.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_dock_controller_finalize;
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_NAME_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_CONFIG_FOLDER_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_CONFIG_FOLDER_PROPERTY] = g_param_spec_object ("config-folder", "config-folder", "config-folder", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_LAUNCHERS_FOLDER_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_LAUNCHERS_FOLDER_PROPERTY] = g_param_spec_object ("launchers-folder", "launchers-folder", "launchers-folder", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_PREFS_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_PREFS_PROPERTY] = g_param_spec_object ("prefs", "prefs", "prefs", PLANK_TYPE_DOCK_PREFERENCES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_DRAG_MANAGER_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_DRAG_MANAGER_PROPERTY] = g_param_spec_object ("drag-manager", "drag-manager", "drag-manager", PLANK_TYPE_DRAG_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_HIDE_MANAGER_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_HIDE_MANAGER_PROPERTY] = g_param_spec_object ("hide-manager", "hide-manager", "hide-manager", PLANK_TYPE_HIDE_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_POSITION_MANAGER_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_POSITION_MANAGER_PROPERTY] = g_param_spec_object ("position-manager", "position-manager", "position-manager", PLANK_TYPE_POSITION_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_RENDERER_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_RENDERER_PROPERTY] = g_param_spec_object ("renderer", "renderer", "renderer", PLANK_TYPE_DOCK_RENDERER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_WINDOW_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", PLANK_TYPE_DOCK_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_HOVER_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_HOVER_PROPERTY] = g_param_spec_object ("hover", "hover", "hover", PLANK_TYPE_HOVER_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_DEFAULT_PROVIDER_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_DEFAULT_PROVIDER_PROPERTY] = g_param_spec_object ("default-provider", "default-provider", "default-provider", PLANK_TYPE_DOCK_ITEM_PROVIDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2384 "DockController.c"
	/**
	 * List of all items on this dock
	 */
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_ITEMS_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_ITEMS_PROPERTY] = g_param_spec_object ("Items", "Items", "Items", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2390 "DockController.c"
	/**
	 * Ordered list of all visible items on this dock
	 */
#line 29 "../lib/DockController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTROLLER_VISIBLE_ITEMS_PROPERTY, plank_dock_controller_properties[PLANK_DOCK_CONTROLLER_VISIBLE_ITEMS_PROPERTY] = g_param_spec_object ("VisibleItems", "VisibleItems", "VisibleItems", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2396 "DockController.c"
}

static void
plank_dock_controller_instance_init (PlankDockController * self,
                                     gpointer klass)
{
#line 29 "../lib/DockController.vala"
	self->priv = plank_dock_controller_get_instance_private (self);
#line 50 "../lib/DockController.vala"
	self->priv->serialize_item_positions_timer_id = 0U;
#line 2407 "DockController.c"
}

static void
plank_dock_controller_finalize (GObject * obj)
{
	PlankDockController * self;
	PlankDockPreferences* _tmp0_;
	guint _tmp1_;
	GQuark _tmp2_;
	PlankDockPreferences* _tmp3_;
	guint _tmp4_;
	GQuark _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
#line 29 "../lib/DockController.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_CONTROLLER, PlankDockController);
#line 108 "../lib/DockController.vala"
	_tmp0_ = self->priv->_prefs;
#line 108 "../lib/DockController.vala"
	g_signal_parse_name ("notify::Position", G_TYPE_OBJECT, &_tmp1_, &_tmp2_, TRUE);
#line 108 "../lib/DockController.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, _tmp2_, NULL, (GCallback) _plank_dock_container_update_visible_elements_g_object_notify, (PlankDockContainer*) self);
#line 109 "../lib/DockController.vala"
	_tmp3_ = self->priv->_prefs;
#line 109 "../lib/DockController.vala"
	g_signal_parse_name ("notify::ShowDockItem", G_TYPE_OBJECT, &_tmp4_, &_tmp5_, TRUE);
#line 109 "../lib/DockController.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, _tmp5_, NULL, (GCallback) _plank_dock_controller_update_show_dock_item_g_object_notify, self);
#line 111 "../lib/DockController.vala"
	g_signal_parse_name ("positions-changed", PLANK_TYPE_DOCK_CONTAINER, &_tmp6_, NULL, FALSE);
#line 111 "../lib/DockController.vala"
	g_signal_handlers_disconnect_matched ((PlankDockContainer*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _plank_dock_controller_handle_positions_changed_plank_dock_container_positions_changed, self);
#line 112 "../lib/DockController.vala"
	g_signal_parse_name ("states-changed", PLANK_TYPE_DOCK_CONTAINER, &_tmp7_, NULL, FALSE);
#line 112 "../lib/DockController.vala"
	g_signal_handlers_disconnect_matched ((PlankDockContainer*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _plank_dock_controller_handle_states_changed_plank_dock_container_states_changed, self);
#line 113 "../lib/DockController.vala"
	g_signal_parse_name ("elements-changed", PLANK_TYPE_DOCK_CONTAINER, &_tmp8_, NULL, FALSE);
#line 113 "../lib/DockController.vala"
	g_signal_handlers_disconnect_matched ((PlankDockContainer*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _plank_dock_controller_handle_elements_changed_plank_dock_container_elements_changed, self);
#line 115 "../lib/DockController.vala"
	if (self->priv->serialize_item_positions_timer_id > 0U) {
#line 116 "../lib/DockController.vala"
		g_source_remove (self->priv->serialize_item_positions_timer_id);
#line 2455 "DockController.c"
	}
#line 117 "../lib/DockController.vala"
	plank_dock_controller_serialize_item_positions (self);
#line 119 "../lib/DockController.vala"
	_tmp9_ = self->priv->items;
#line 119 "../lib/DockController.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp9_);
#line 120 "../lib/DockController.vala"
	_tmp10_ = self->priv->visible_items;
#line 120 "../lib/DockController.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp10_);
#line 31 "../lib/DockController.vala"
	_g_free0 (self->priv->_name);
#line 32 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->_config_folder);
#line 33 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->_launchers_folder);
#line 35 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->_prefs);
#line 37 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->_drag_manager);
#line 38 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->_hide_manager);
#line 39 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->_position_manager);
#line 40 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->_renderer);
#line 41 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->_window);
#line 42 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->_hover);
#line 44 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->_default_provider);
#line 46 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->dbus_manager);
#line 47 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->visible_items);
#line 48 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->items);
#line 49 "../lib/DockController.vala"
	_g_object_unref0 (self->priv->dock_itself_item);
#line 29 "../lib/DockController.vala"
	G_OBJECT_CLASS (plank_dock_controller_parent_class)->finalize (obj);
#line 2499 "DockController.c"
}

/**
 * A controller class for managing a single dock.
 *
 * All needed controlling parts will be created and initialized.
 */
static GType
plank_dock_controller_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDockControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dock_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockController), 0, (GInstanceInitFunc) plank_dock_controller_instance_init, NULL };
	GType plank_dock_controller_type_id;
	plank_dock_controller_type_id = g_type_register_static (PLANK_TYPE_DOCK_CONTAINER, "PlankDockController", &g_define_type_info, 0);
	PlankDockController_private_offset = g_type_add_instance_private (plank_dock_controller_type_id, sizeof (PlankDockControllerPrivate));
	return plank_dock_controller_type_id;
}

GType
plank_dock_controller_get_type (void)
{
	static volatile gsize plank_dock_controller_type_id__once = 0;
	if (g_once_init_enter (&plank_dock_controller_type_id__once)) {
		GType plank_dock_controller_type_id;
		plank_dock_controller_type_id = plank_dock_controller_get_type_once ();
		g_once_init_leave (&plank_dock_controller_type_id__once, plank_dock_controller_type_id);
	}
	return plank_dock_controller_type_id__once;
}

static void
_vala_plank_dock_controller_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	PlankDockController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_CONTROLLER, PlankDockController);
#line 29 "../lib/DockController.vala"
	switch (property_id) {
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_NAME_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_string (value, plank_dock_controller_get_name (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_CONFIG_FOLDER_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_config_folder (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_LAUNCHERS_FOLDER_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_launchers_folder (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_PREFS_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_prefs (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_DRAG_MANAGER_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_drag_manager (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_HIDE_MANAGER_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_hide_manager (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_POSITION_MANAGER_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_position_manager (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_RENDERER_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_renderer (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_WINDOW_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_window (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_HOVER_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_hover (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_DEFAULT_PROVIDER_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_default_provider (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_ITEMS_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_Items (self));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_VISIBLE_ITEMS_PROPERTY:
#line 29 "../lib/DockController.vala"
		g_value_set_object (value, plank_dock_controller_get_VisibleItems (self));
#line 29 "../lib/DockController.vala"
		break;
#line 2617 "DockController.c"
		default:
#line 29 "../lib/DockController.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../lib/DockController.vala"
		break;
#line 2623 "DockController.c"
	}
}

static void
_vala_plank_dock_controller_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	PlankDockController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_CONTROLLER, PlankDockController);
#line 29 "../lib/DockController.vala"
	switch (property_id) {
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_NAME_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_name (self, g_value_get_string (value));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_CONFIG_FOLDER_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_config_folder (self, g_value_get_object (value));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_LAUNCHERS_FOLDER_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_launchers_folder (self, g_value_get_object (value));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_PREFS_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_prefs (self, g_value_get_object (value));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_DRAG_MANAGER_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_drag_manager (self, g_value_get_object (value));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_HIDE_MANAGER_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_hide_manager (self, g_value_get_object (value));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_POSITION_MANAGER_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_position_manager (self, g_value_get_object (value));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_RENDERER_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_renderer (self, g_value_get_object (value));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_WINDOW_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_window (self, g_value_get_object (value));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_HOVER_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_hover (self, g_value_get_object (value));
#line 29 "../lib/DockController.vala"
		break;
#line 29 "../lib/DockController.vala"
		case PLANK_DOCK_CONTROLLER_DEFAULT_PROVIDER_PROPERTY:
#line 29 "../lib/DockController.vala"
		plank_dock_controller_set_default_provider (self, g_value_get_object (value));
#line 29 "../lib/DockController.vala"
		break;
#line 2703 "DockController.c"
		default:
#line 29 "../lib/DockController.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../lib/DockController.vala"
		break;
#line 2709 "DockController.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

